/* A Bison parser, made by GNU Bison 1.875.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     STRING = 258,
     LINE = 259,
     INTERACT = 260,
     SOURCE = 261,
     AND = 262,
     AS = 263,
     CONST = 264,
     DEF = 265,
     DIV = 266,
     ELSE = 267,
     EXTERN = 268,
     IF = 269,
     IMPORT = 270,
     IN = 271,
     INCLUDE = 272,
     MOD = 273,
     NOT = 274,
     OR = 275,
     OTHERWISE = 276,
     PRIVATE = 277,
     PUBLIC = 278,
     SPECIAL = 279,
     THEN = 280,
     TYPE = 281,
     UNDEF = 282,
     VAR = 283,
     WHERE = 284,
     DOTDOT = 285,
     CAT = 286,
     DBAR = 287,
     LEQ = 288,
     GEQ = 289,
     NEQ = 290,
     _DEF_ = 291,
     _UNDEF_ = 292,
     _IMPORT_ = 293,
     _COPYING_ = 294,
     _HELP_ = 295,
     _EDIT_ = 296,
     _PATH_ = 297,
     _PROMPT_ = 298,
     _HISTFILE_ = 299,
     _HISTSIZE_ = 300,
     _STACKSIZE_ = 301,
     _MEMSIZE_ = 302,
     _STATS_ = 303,
     _RUN_ = 304,
     _SAVE_ = 305,
     _LOAD_ = 306,
     _CLEAR_ = 307,
     _PROFILE_ = 308,
     _BREAK_ = 309,
     _TBREAK_ = 310,
     _DEBUG_ = 311,
     _ECHO_ = 312,
     _CHDIR_ = 313,
     _PWD_ = 314,
     _LS_ = 315,
     _WHICH_ = 316,
     _SOURCE_ = 317,
     _WHO_ = 318,
     _WHOS_ = 319,
     _IMPORTS_ = 320,
     _MODULES_ = 321,
     _COMPLETION_MATCHES_ = 322,
     _DEC_ = 323,
     _HEX_ = 324,
     _OCT_ = 325,
     _STD_ = 326,
     _SCI_ = 327,
     _FIX_ = 328,
     _FORMAT_ = 329,
     XID = 330,
     ID = 331,
     STR = 332,
     INT = 333,
     FLOAT = 334,
     ARG = 335,
     ERRTOK = 336,
     ARGERR = 337,
     STRERR = 338
   };
#endif
#define STRING 258
#define LINE 259
#define INTERACT 260
#define SOURCE 261
#define AND 262
#define AS 263
#define CONST 264
#define DEF 265
#define DIV 266
#define ELSE 267
#define EXTERN 268
#define IF 269
#define IMPORT 270
#define IN 271
#define INCLUDE 272
#define MOD 273
#define NOT 274
#define OR 275
#define OTHERWISE 276
#define PRIVATE 277
#define PUBLIC 278
#define SPECIAL 279
#define THEN 280
#define TYPE 281
#define UNDEF 282
#define VAR 283
#define WHERE 284
#define DOTDOT 285
#define CAT 286
#define DBAR 287
#define LEQ 288
#define GEQ 289
#define NEQ 290
#define _DEF_ 291
#define _UNDEF_ 292
#define _IMPORT_ 293
#define _COPYING_ 294
#define _HELP_ 295
#define _EDIT_ 296
#define _PATH_ 297
#define _PROMPT_ 298
#define _HISTFILE_ 299
#define _HISTSIZE_ 300
#define _STACKSIZE_ 301
#define _MEMSIZE_ 302
#define _STATS_ 303
#define _RUN_ 304
#define _SAVE_ 305
#define _LOAD_ 306
#define _CLEAR_ 307
#define _PROFILE_ 308
#define _BREAK_ 309
#define _TBREAK_ 310
#define _DEBUG_ 311
#define _ECHO_ 312
#define _CHDIR_ 313
#define _PWD_ 314
#define _LS_ 315
#define _WHICH_ 316
#define _SOURCE_ 317
#define _WHO_ 318
#define _WHOS_ 319
#define _IMPORTS_ 320
#define _MODULES_ 321
#define _COMPLETION_MATCHES_ 322
#define _DEC_ 323
#define _HEX_ 324
#define _OCT_ 325
#define _STD_ 326
#define _SCI_ 327
#define _FIX_ 328
#define _FORMAT_ 329
#define XID 330
#define ID 331
#define STR 332
#define INT 333
#define FLOAT 334
#define ARG 335
#define ERRTOK 336
#define ARGERR 337
#define STRERR 338




/* Copy the first part of user declarations.  */
#line 2 "qmparse.y"


/* qmparse.y: Q machine expression parser */

/* Special case constructs (unary minus, 1-tuples) cause a number of parsing
   conflicts which are resolved correctly. */

/*  Q eQuational Programming System
    Copyright (c) 1991-2002 by Albert Graef
    <ag@muwiinfa.geschichte.uni-mainz.de>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 1, or (at your option)
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/

/* make sure we have bison */

#ifndef YYBISON
#error "Sorry, this program requires bison."
#endif

#include "qdefs.h"

extern char *prompt, *prompt2, *prompt3;
extern int pmode;

static char		signon[] = Q_SIGNON;
static char		copying[] = COPYING;

static char *psource = "";

static char  *save_file = NULL;
static char *base;

static THREAD *thr;

/*

This module implements a parser for Q expressions and the special
constructs (def, undef, etc.) permitted in the interactive evaluation
loop. The parser can be run in four different modes signalled by special
leading tokens:

- STRING: read a single expression from a null-terminated string.

- LINE: read an expression terminated with newline from a file.

- INTERACT: read and evaluate a command (including def's,
  undef's and shell escapes) from a null-terminated string.

- SOURCE: read and evaluate commands from a file

*/

static swap(), pushbin(), pushun(), pushlist(), pushtuple(), savepos(),
  clean();
static init_stats(), fini_stats(), print_stats();
static copyright(), shell(), expression(), assignment(), unassignment(),
  sethistfile(), sethistsize(), help(), edit(), save_vars(), clear_vars(),
  add_import(), del_import(), clear_imports(), breakpoints(), profile(),
  who(), whos(), import_list(), modules();
static strparam(), intparam(), boolparam(), boolstrparam(), allparam(),
  strlist(), printstr();

/* The following is set to compile for the libqint target. */
#ifdef QINT_LIBRARY
#undef USE_READLINE
#endif

#ifndef USE_READLINE
static histwarn();
#endif

#define MAXARGC 1000


/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
#line 90 "qmparse.y"
typedef union YYSTYPE {
  int ival;
  mpz_t zval;
  double fval;
  char *sval;
  EXPR *xval;
  struct {
    char **v;
    int c;
  } aval;
} YYSTYPE;
/* Line 191 of yacc.c.  */
#line 341 "qmparse.c"
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 214 of yacc.c.  */
#line 353 "qmparse.c"

#if ! defined (yyoverflow) || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# if YYSTACK_USE_ALLOCA
#  define YYSTACK_ALLOC alloca
# else
#  ifndef YYSTACK_USE_ALLOCA
#   if defined (alloca) || defined (_ALLOCA_H)
#    define YYSTACK_ALLOC alloca
#   else
#    ifdef __GNUC__
#     define YYSTACK_ALLOC __builtin_alloca
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC malloc
#  define YYSTACK_FREE free
# endif
#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char yysigned_char;
#else
   typedef short yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  78
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   1150

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  106
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  49
/* YYNRULES -- Number of rules. */
#define YYNRULES  231
/* YYNRULES -- Number of states. */
#define YYNSTATES  326

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   338

#define YYTRANSLATE(YYX) 						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      84,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    85,     2,    97,     2,     2,     2,   100,
      87,    88,    95,    94,    89,    93,    99,    96,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,    86,
      91,    90,    92,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   104,     2,   105,    98,     2,   101,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,   103,     2,   102,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned short yyprhs[] =
{
       0,     0,     3,     6,     9,    13,    16,    19,    20,    21,
      23,    25,    28,    30,    34,    36,    39,    42,    44,    47,
      49,    52,    54,    57,    60,    62,    64,    66,    68,    70,
      73,    75,    78,    80,    83,    85,    88,    90,    93,    95,
      98,   100,   103,   105,   108,   110,   112,   115,   118,   121,
     123,   126,   129,   132,   134,   137,   139,   142,   145,   148,
     152,   156,   158,   161,   163,   166,   168,   171,   174,   176,
     179,   181,   184,   187,   189,   191,   193,   196,   199,   201,
     202,   207,   209,   212,   214,   216,   219,   221,   223,   226,
     228,   230,   233,   235,   237,   240,   242,   244,   247,   249,
     251,   254,   256,   258,   262,   263,   266,   267,   270,   272,
     274,   276,   280,   284,   286,   290,   292,   294,   298,   300,
     304,   306,   308,   310,   312,   314,   316,   318,   322,   324,
     328,   330,   332,   334,   336,   338,   340,   342,   344,   348,
     352,   354,   356,   358,   361,   363,   367,   369,   371,   373,
     375,   377,   380,   382,   385,   388,   391,   394,   396,   398,
     400,   404,   406,   408,   410,   414,   416,   419,   421,   423,
     425,   427,   429,   431,   433,   435,   439,   441,   444,   449,
     454,   459,   464,   469,   474,   479,   484,   489,   494,   499,
     504,   509,   512,   516,   520,   526,   532,   540,   543,   547,
     553,   554,   561,   563,   565,   569,   571,   573,   575,   577,
     579,   581,   583,   585,   587,   589,   591,   593,   596,   598,
     600,   602,   604,   606,   609,   611,   613,   615,   617,   619,
     621,   623
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const short yyrhs[] =
{
     107,     0,    -1,     3,   137,    -1,     4,   137,    -1,     4,
     137,    84,    -1,     5,   108,    -1,     6,   108,    -1,    -1,
      -1,    85,    -1,   109,    -1,   109,    86,    -1,   110,    -1,
     109,    86,   110,    -1,   137,    -1,    36,   130,    -1,    37,
     132,    -1,    39,    -1,    67,   129,    -1,    40,    -1,    40,
     129,    -1,    42,    -1,    42,   129,    -1,    43,   128,    -1,
      74,    -1,    68,    -1,    69,    -1,    70,    -1,    71,    -1,
      71,   129,    -1,    72,    -1,    72,   129,    -1,    73,    -1,
      73,   129,    -1,    44,    -1,    44,   129,    -1,    45,    -1,
      45,   129,    -1,    46,    -1,    46,   129,    -1,    47,    -1,
      47,   129,    -1,    48,    -1,    48,   129,    -1,    59,    -1,
      58,    -1,    58,   129,    -1,    60,   128,    -1,    56,   128,
      -1,    54,    -1,    54,   129,    -1,    54,   112,    -1,    55,
     114,    -1,    53,    -1,    53,   116,    -1,    52,    -1,    52,
      54,    -1,    52,    53,    -1,    52,   118,    -1,    52,    54,
     120,    -1,    52,    53,   122,    -1,    57,    -1,    57,   129,
      -1,    61,    -1,    61,   129,    -1,    41,    -1,    41,   129,
      -1,    62,   129,    -1,    51,    -1,    51,   129,    -1,    50,
      -1,    50,   129,    -1,    38,   128,    -1,    65,    -1,    66,
      -1,    63,    -1,    63,   129,    -1,    64,   124,    -1,    49,
      -1,    -1,    49,   129,   111,   127,    -1,   113,    -1,   112,
     113,    -1,   126,    -1,   115,    -1,   114,   115,    -1,   126,
      -1,   117,    -1,   116,   117,    -1,   126,    -1,   119,    -1,
     118,   119,    -1,   126,    -1,   121,    -1,   120,   121,    -1,
     126,    -1,   123,    -1,   122,   123,    -1,   126,    -1,   125,
      -1,   124,   125,    -1,   126,    -1,    76,    -1,    87,   154,
      88,    -1,    -1,   127,   129,    -1,    -1,   128,   129,    -1,
      80,    -1,    82,    -1,   131,    -1,   130,    89,   131,    -1,
     134,    90,   134,    -1,   133,    -1,   132,    89,   133,    -1,
      76,    -1,   135,    -1,   134,    32,   135,    -1,   140,    -1,
     140,   136,   140,    -1,    91,    -1,    92,    -1,    33,    -1,
      34,    -1,    35,    -1,    16,    -1,   138,    -1,   137,    32,
     138,    -1,   140,    -1,   140,   139,   140,    -1,    91,    -1,
      92,    -1,    90,    -1,    33,    -1,    34,    -1,    35,    -1,
      16,    -1,   142,    -1,   140,   141,   142,    -1,   140,    93,
     142,    -1,    94,    -1,    31,    -1,    20,    -1,    20,    12,
      -1,   144,    -1,   142,   143,   144,    -1,    95,    -1,    96,
      -1,    11,    -1,    18,    -1,     7,    -1,     7,    25,    -1,
     146,    -1,    93,    78,    -1,    93,    79,    -1,    93,   144,
      -1,   145,   144,    -1,    97,    -1,    19,    -1,   148,    -1,
     148,   147,   146,    -1,    98,    -1,    85,    -1,   149,    -1,
     148,    99,   149,    -1,   151,    -1,   149,   151,    -1,   100,
      -1,   101,    -1,   102,    -1,    78,    -1,    79,    -1,    77,
      -1,    83,    -1,    76,    -1,    87,   154,    88,    -1,    75,
      -1,   150,   151,    -1,    87,   137,    32,    88,    -1,    87,
      32,   138,    88,    -1,    87,   140,   139,    88,    -1,    87,
     139,   140,    88,    -1,    87,   140,   141,    88,    -1,    87,
     140,    93,    88,    -1,    87,   141,   142,    88,    -1,    87,
     142,   143,    88,    -1,    87,   143,   144,    88,    -1,    87,
     148,   147,    88,    -1,    87,   147,   146,    88,    -1,    87,
     148,    99,    88,    -1,    87,    99,   149,    88,    -1,    87,
      88,    -1,    87,   151,    88,    -1,    87,   137,    88,    -1,
      87,   137,   103,   137,    88,    -1,    87,   137,    89,   153,
      88,    -1,    87,   137,    89,   153,   103,   137,    88,    -1,
     104,   105,    -1,   104,   153,   105,    -1,   104,   153,   103,
     137,   105,    -1,    -1,   104,   153,    30,   152,   137,   105,
      -1,     1,    -1,   137,    -1,   153,    89,   137,    -1,    32,
      -1,    91,    -1,    92,    -1,    90,    -1,    33,    -1,    34,
      -1,    35,    -1,    16,    -1,    31,    -1,    94,    -1,    93,
      -1,    20,    -1,    20,    12,    -1,    95,    -1,    96,    -1,
      11,    -1,    18,    -1,     7,    -1,     7,    25,    -1,    97,
      -1,    19,    -1,   100,    -1,   101,    -1,   102,    -1,    98,
      -1,    85,    -1,    99,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned short yyrline[] =
{
       0,   145,   145,   146,   147,   149,   150,   152,   156,   157,
     159,   160,   163,   164,   169,   172,   174,   176,   179,   189,
     200,   214,   220,   235,   261,   276,   279,   282,   285,   292,
     308,   315,   331,   338,   354,   363,   373,   382,   392,   398,
     415,   421,   439,   442,   445,   458,   472,   500,   524,   566,
     572,   582,   584,   586,   592,   594,   600,   616,   629,   631,
     633,   635,   641,   656,   662,   694,   703,   724,   747,   768,
     795,   810,   829,   852,   855,   858,   861,   864,   866,   870,
     869,   897,   897,   899,   924,   924,   926,   951,   951,   953,
     971,   971,   973,   986,   986,   988,  1009,  1009,  1011,  1029,
    1029,  1031,  1033,  1033,  1038,  1043,  1068,  1080,  1102,  1103,
    1107,  1108,  1111,  1115,  1116,  1119,  1123,  1124,  1128,  1129,
    1133,  1134,  1135,  1136,  1137,  1138,  1141,  1142,  1146,  1147,
    1151,  1152,  1153,  1154,  1155,  1156,  1157,  1160,  1161,  1163,
    1167,  1168,  1169,  1170,  1173,  1174,  1178,  1179,  1180,  1181,
    1182,  1183,  1188,  1189,  1191,  1192,  1193,  1196,  1197,  1200,
    1201,  1205,  1206,  1209,  1210,  1214,  1215,  1219,  1220,  1221,
    1227,  1228,  1229,  1230,  1234,  1236,  1240,  1244,  1249,  1252,
    1257,  1260,  1265,  1268,  1271,  1276,  1279,  1284,  1287,  1292,
    1295,  1303,  1305,  1308,  1309,  1311,  1314,  1319,  1321,  1324,
    1327,  1326,  1333,  1340,  1342,  1346,  1347,  1348,  1349,  1350,
    1351,  1352,  1353,  1354,  1355,  1356,  1357,  1358,  1359,  1360,
    1361,  1362,  1363,  1364,  1365,  1366,  1367,  1368,  1369,  1370,
    1371,  1372
};
#endif

#if YYDEBUG || YYERROR_VERBOSE
/* YYTNME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "STRING", "LINE", "INTERACT", "SOURCE", 
  "AND", "AS", "CONST", "DEF", "DIV", "ELSE", "EXTERN", "IF", "IMPORT", 
  "IN", "INCLUDE", "MOD", "NOT", "OR", "OTHERWISE", "PRIVATE", "PUBLIC", 
  "SPECIAL", "THEN", "TYPE", "UNDEF", "VAR", "WHERE", "DOTDOT", "CAT", 
  "DBAR", "LEQ", "GEQ", "NEQ", "_DEF_", "_UNDEF_", "_IMPORT_", 
  "_COPYING_", "_HELP_", "_EDIT_", "_PATH_", "_PROMPT_", "_HISTFILE_", 
  "_HISTSIZE_", "_STACKSIZE_", "_MEMSIZE_", "_STATS_", "_RUN_", "_SAVE_", 
  "_LOAD_", "_CLEAR_", "_PROFILE_", "_BREAK_", "_TBREAK_", "_DEBUG_", 
  "_ECHO_", "_CHDIR_", "_PWD_", "_LS_", "_WHICH_", "_SOURCE_", "_WHO_", 
  "_WHOS_", "_IMPORTS_", "_MODULES_", "_COMPLETION_MATCHES_", "_DEC_", 
  "_HEX_", "_OCT_", "_STD_", "_SCI_", "_FIX_", "_FORMAT_", "XID", "ID", 
  "STR", "INT", "FLOAT", "ARG", "ERRTOK", "ARGERR", "STRERR", "'\\n'", 
  "'!'", "';'", "'('", "')'", "','", "'='", "'<'", "'>'", "'-'", "'+'", 
  "'*'", "'/'", "'#'", "'^'", "'.'", "'''", "'`'", "'~'", "'|'", "'['", 
  "']'", "$accept", "source", "input", "commands", "command", "@1", 
  "breaksyms", "breaksym", "tbreaksyms", "tbreaksym", "profilesyms", 
  "profilesym", "clearsyms", "clearsym", "clearbreaksyms", 
  "clearbreaksym", "clearprofilesyms", "clearprofilesym", "whossyms", 
  "whossym", "symbol", "opt_arg_list", "arg_list", "arg", "defs", "def", 
  "undefs", "undef", "lexpression", "lrelation", "lrelop", "expression", 
  "relation", "relop", "addition", "addop", "multiplication", "mulop", 
  "unary", "unop", "script", "scriptop", "composition", "application", 
  "quoteop", "primary", "@2", "expr_list", "op", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,    10,    33,    59,    40,    41,    44,
      61,    60,    62,    45,    43,    42,    47,    35,    94,    46,
      39,    96,   126,   124,    91,    93
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned char yyr1[] =
{
       0,   106,   107,   107,   107,   107,   107,   107,   108,   108,
     108,   108,   109,   109,   110,   110,   110,   110,   110,   110,
     110,   110,   110,   110,   110,   110,   110,   110,   110,   110,
     110,   110,   110,   110,   110,   110,   110,   110,   110,   110,
     110,   110,   110,   110,   110,   110,   110,   110,   110,   110,
     110,   110,   110,   110,   110,   110,   110,   110,   110,   110,
     110,   110,   110,   110,   110,   110,   110,   110,   110,   110,
     110,   110,   110,   110,   110,   110,   110,   110,   110,   111,
     110,   112,   112,   113,   114,   114,   115,   116,   116,   117,
     118,   118,   119,   120,   120,   121,   122,   122,   123,   124,
     124,   125,   126,   126,   127,   127,   128,   128,   129,   129,
     130,   130,   131,   132,   132,   133,   134,   134,   135,   135,
     136,   136,   136,   136,   136,   136,   137,   137,   138,   138,
     139,   139,   139,   139,   139,   139,   139,   140,   140,   140,
     141,   141,   141,   141,   142,   142,   143,   143,   143,   143,
     143,   143,   144,   144,   144,   144,   144,   145,   145,   146,
     146,   147,   147,   148,   148,   149,   149,   150,   150,   150,
     151,   151,   151,   151,   151,   151,   151,   151,   151,   151,
     151,   151,   151,   151,   151,   151,   151,   151,   151,   151,
     151,   151,   151,   151,   151,   151,   151,   151,   151,   151,
     152,   151,   151,   153,   153,   154,   154,   154,   154,   154,
     154,   154,   154,   154,   154,   154,   154,   154,   154,   154,
     154,   154,   154,   154,   154,   154,   154,   154,   154,   154,
     154,   154
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     2,     2,     3,     2,     2,     0,     0,     1,
       1,     2,     1,     3,     1,     2,     2,     1,     2,     1,
       2,     1,     2,     2,     1,     1,     1,     1,     1,     2,
       1,     2,     1,     2,     1,     2,     1,     2,     1,     2,
       1,     2,     1,     2,     1,     1,     2,     2,     2,     1,
       2,     2,     2,     1,     2,     1,     2,     2,     2,     3,
       3,     1,     2,     1,     2,     1,     2,     2,     1,     2,
       1,     2,     2,     1,     1,     1,     2,     2,     1,     0,
       4,     1,     2,     1,     1,     2,     1,     1,     2,     1,
       1,     2,     1,     1,     2,     1,     1,     2,     1,     1,
       2,     1,     1,     3,     0,     2,     0,     2,     1,     1,
       1,     3,     3,     1,     3,     1,     1,     3,     1,     3,
       1,     1,     1,     1,     1,     1,     1,     3,     1,     3,
       1,     1,     1,     1,     1,     1,     1,     1,     3,     3,
       1,     1,     1,     2,     1,     3,     1,     1,     1,     1,
       1,     2,     1,     2,     2,     2,     2,     1,     1,     1,
       3,     1,     1,     1,     3,     1,     2,     1,     1,     1,
       1,     1,     1,     1,     1,     3,     1,     2,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     2,     3,     3,     5,     5,     7,     2,     3,     5,
       0,     6,     1,     1,     3,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     2,     1,     1,
       1,     1,     1,     2,     1,     1,     1,     1,     1,     1,
       1,     1
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned char yydefact[] =
{
       7,     0,     0,     0,     0,     0,   202,   158,   176,   174,
     172,   170,   171,   173,     0,     0,   157,   167,   168,   169,
       0,     2,   126,   128,   137,   144,     0,   152,   159,     0,
       0,   165,     3,     0,     0,   106,    17,    19,    65,    21,
     106,    34,    36,    38,    40,    42,    78,    70,    68,    55,
      53,    49,     0,   106,    61,    45,    44,   106,    63,     0,
      75,     0,    73,    74,     0,    25,    26,    27,    28,    30,
      32,    24,     9,     5,    10,    12,    14,     6,     1,   150,
     148,   136,   149,   158,   142,   141,     0,   133,   134,   135,
     162,   191,   132,   130,   131,     0,   140,   146,   147,   157,
     161,     0,   167,   168,   169,     0,     0,   128,     0,   137,
       0,     0,   159,   165,     0,   153,   154,   155,   197,   203,
       0,     0,   136,   142,   141,   133,   134,   135,   132,   130,
     131,     0,   140,     0,     0,   150,   148,   149,   146,   147,
       0,   156,   162,   161,     0,     0,   166,   177,     4,    15,
     110,     0,   116,   118,   115,    16,   113,    72,   108,   109,
      20,    66,    22,    23,    35,    37,    39,    41,    43,    79,
      71,    69,    57,    56,   102,     0,    58,    90,    92,    54,
      87,    89,    51,    81,    83,    50,    52,    84,    86,    48,
      62,    46,    47,    64,    67,    76,    77,    99,   101,    18,
      29,    31,    33,     0,   151,   143,     0,     0,     0,   193,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   192,   175,   200,     0,     0,   198,   127,   143,
     139,   129,   138,   151,   145,     0,   160,     0,     0,     0,
     125,   122,   123,   124,   120,   121,     0,     0,   107,   104,
      60,    96,    98,    59,    93,    95,   222,   220,   212,   221,
     225,   216,   213,   205,   209,   210,   211,   230,   208,   206,
     207,   215,   214,   218,   219,   224,   229,   231,   226,   227,
     228,     0,    91,    88,    82,    85,   100,    13,   179,   190,
     178,     0,     0,   181,   183,   180,   182,   184,   185,   186,
     188,   189,   187,     0,   204,     0,   111,   117,   112,   119,
     114,    80,    97,    94,   223,   217,   103,   195,     0,   194,
       0,   199,   105,     0,   201,   196
};

/* YYDEFGOTO[NTERM-NUM]. */
static const short yydefgoto[] =
{
      -1,     5,    73,    74,    75,   249,   182,   183,   186,   187,
     179,   180,   176,   177,   253,   254,   250,   251,   196,   197,
     178,   311,   157,   248,   149,   150,   155,   156,   151,   152,
     246,    76,    22,   106,    23,   134,    24,   140,    25,    26,
      27,   111,    28,    29,    30,    31,   303,   120,   114
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -110
static const short yypact[] =
{
     150,   774,   774,   351,   351,    63,  -110,  -110,  -110,  -110,
    -110,  -110,  -110,  -110,   518,   804,  -110,  -110,  -110,  -110,
     280,    38,  -110,  1008,    48,  -110,   774,  -110,   -17,    85,
     974,  -110,    24,   774,   -30,  -110,  -110,    27,    27,    27,
    -110,    27,    27,    27,    27,    27,    27,    27,    27,   143,
      -7,   141,    -7,  -110,    27,    27,  -110,  -110,    27,    27,
      27,    -7,  -110,  -110,    27,  -110,  -110,  -110,    27,    27,
      27,  -110,  -110,  -110,   -28,  -110,    38,  -110,  -110,    10,
     -13,    -9,    -5,     9,     3,    12,   553,    23,    42,    45,
      59,  -110,    62,    71,    77,   583,    79,    94,   103,   104,
     107,   864,   110,   111,   112,   105,   774,  1038,   774,    48,
     774,   974,   -11,   113,   114,   210,   834,  -110,  -110,    38,
      35,   774,  -110,    55,  -110,  -110,  -110,  -110,  -110,  -110,
    -110,   774,  -110,   774,   774,    89,  -110,  -110,  -110,  -110,
     774,  -110,  -110,  -110,   974,   974,  -110,  -110,  -110,    13,
    -110,     0,  -110,   429,  -110,   115,  -110,    27,  -110,  -110,
    -110,  -110,  -110,    27,  -110,  -110,  -110,  -110,  -110,  -110,
    -110,  -110,    -7,    -7,  -110,  1048,    -7,  -110,  -110,    -7,
    -110,  -110,    -7,  -110,  -110,  -110,    -7,  -110,  -110,    27,
    -110,  -110,    27,  -110,  -110,  -110,    -7,  -110,  -110,  -110,
    -110,  -110,  -110,   431,   117,   119,   125,   884,   620,  -110,
     774,   774,    58,   650,   681,   711,    46,   743,   126,   127,
     914,   944,  -110,  -110,  -110,   774,   774,  -110,  -110,  -110,
      48,    64,    48,  -110,  -110,   245,  -110,   774,   774,   774,
    -110,  -110,  -110,  -110,  -110,  -110,   774,   -30,  -110,  -110,
      -7,  -110,  -110,    -7,  -110,  -110,   191,  -110,  -110,  -110,
    -110,   206,  -110,  -110,  -110,  -110,  -110,  -110,  -110,  -110,
    -110,  -110,  -110,  -110,  -110,  -110,  -110,  -110,  -110,  -110,
    -110,   132,  -110,  -110,  -110,  -110,  -110,  -110,  -110,  -110,
    -110,   -27,    22,  -110,  -110,  -110,  -110,  -110,  -110,  -110,
    -110,  -110,  -110,   774,    38,     8,  -110,  -110,    39,    64,
    -110,    27,  -110,  -110,  -110,  -110,  -110,  -110,   774,  -110,
      18,  -110,  -110,    40,  -110,  -110
};

/* YYPGOTO[NTERM-NUM].  */
static const short yypgoto[] =
{
    -110,  -110,   222,  -110,    28,  -110,  -110,    50,  -110,    47,
    -110,    60,  -110,    65,  -110,   -19,  -110,   -12,  -110,    44,
     -47,  -110,    20,   -21,  -110,     5,  -110,     1,    16,    11,
    -110,    -1,   -79,   -14,    -2,    -8,    14,    -3,    26,  -110,
    -109,   -18,   233,   -93,  -110,    15,  -110,    41,    78
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -232
static const short yytable[] =
{
      21,    32,   219,   181,   184,   188,   108,   206,   207,   133,
     145,   110,   107,   105,   198,   205,   160,   161,   162,   119,
     164,   165,   166,   167,   168,   169,   170,   171,   109,   113,
     185,   153,   238,   190,   191,   204,   236,   193,   194,   195,
     121,   117,   228,   199,   146,   147,   154,   200,   201,   202,
     121,   235,   141,   135,   121,   135,   121,   136,   203,   136,
     163,   317,   225,    78,   137,   224,   137,   229,   142,   174,
     121,   238,   121,   189,   142,  -220,   318,   192,   123,  -212,
     175,   143,   144,  -221,   123,  -163,     6,   143,   220,   124,
     239,  -216,  -163,   214,   221,   124,  -163,  -225,  -222,   215,
    -213,  -163,   237,  -163,   212,  -163,   217,   158,   148,   159,
     319,  -209,   236,   321,   233,  -163,  -163,  -163,  -163,  -163,
    -163,   117,   216,   324,   225,   252,   255,   235,   325,   228,
    -210,   231,   181,  -211,   297,   184,   218,   208,   226,   188,
     227,   138,   139,   138,   139,   230,   293,  -230,   232,   198,
    -208,   131,   132,     1,     2,     3,     4,   131,   132,  -206,
       8,     9,    10,    11,    12,  -207,   234,  -214,    13,  -163,
    -163,  -163,    14,  -163,  -163,  -163,  -163,  -163,  -163,  -163,
    -163,  -163,  -218,  -163,  -163,    17,    18,    19,  -163,    20,
    -163,  -219,  -224,   209,   210,  -229,   172,   173,  -226,  -227,
    -228,   222,   223,   252,   247,  -223,   255,  -217,   211,   119,
     292,  -170,   231,   288,   299,   300,   314,   174,   315,   174,
     316,   158,   146,   159,   304,   305,    77,   230,   175,   232,
     175,   287,   284,   285,   313,   153,   153,   153,   312,   283,
     286,   282,   306,   234,   309,  -164,     6,   112,   310,   307,
     146,   291,  -164,   281,     0,   308,  -164,     0,     0,     0,
       0,  -164,     0,  -164,     0,  -164,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  -164,  -164,  -164,  -164,  -164,
    -164,     6,     0,     0,     0,  -170,  -170,  -170,  -170,  -170,
     322,     0,     0,  -170,     0,  -170,     0,  -170,     0,     7,
       0,     0,   320,     0,     0,     0,     0,     0,  -170,  -170,
    -170,  -170,  -170,     0,  -170,     0,     0,   323,     0,     0,
       8,     9,    10,    11,    12,     0,     0,     0,    13,  -164,
    -164,  -164,    14,  -164,  -164,  -164,  -164,  -164,  -164,  -164,
    -164,  -164,     0,  -164,  -164,    17,    18,    19,  -164,    20,
    -164,    -8,     6,     0,     0,     8,     9,    10,    11,    12,
       0,     0,     0,    13,     0,     0,     0,    14,     0,     0,
       7,     0,     0,    15,     0,     0,     0,    16,     0,     0,
      17,    18,    19,     0,    20,   118,     0,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,     8,     9,    10,    11,
      12,   -11,     6,     0,    13,     0,    72,     0,    14,     0,
       0,     0,     0,     0,    15,   240,     0,     0,    16,   123,
       7,    17,    18,    19,     0,    20,     0,     0,     0,     0,
     124,     0,   241,   242,   243,     0,     0,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,     8,     9,    10,    11,
      12,     0,     0,     0,    13,     0,     0,     0,    14,     6,
     244,   245,   131,   132,    15,    79,     0,     0,    16,    80,
       0,    17,    18,    19,    81,    20,    82,    83,    84,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    85,
      86,    87,    88,    89,     6,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     7,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     6,     0,     0,     0,     0,     0,
       0,     0,     0,     8,     9,    10,    11,    12,     0,     0,
       0,    13,     7,    90,     0,    14,    91,     0,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,     6,    20,     0,     0,     0,     0,     0,     8,     9,
      10,    11,    12,     0,     0,     0,    13,     0,     0,     7,
      14,  -205,     0,     0,     0,     0,    15,     0,     0,     0,
      16,     6,     0,    17,    18,    19,     0,    20,     8,     9,
      10,   115,   116,     0,     0,     0,    13,     0,     0,     7,
      14,  -215,     0,     0,     0,     0,    15,     0,     0,     0,
      16,     0,     6,    17,    18,    19,     0,    20,     0,     0,
       0,     0,     0,     0,     0,     8,     9,    10,    11,    12,
       7,     0,     0,    13,     0,     0,     0,    14,   290,     0,
       0,     0,     6,    15,     0,     0,     0,    16,     0,     0,
      17,    18,    19,     0,    20,     8,     9,    10,    11,    12,
       7,     0,     0,    13,     0,     0,     0,    14,   294,     0,
       0,     0,     0,    15,     6,     0,     0,    16,     0,     0,
      17,    18,    19,     0,    20,     0,     8,     9,    10,    11,
      12,     0,     7,     0,    13,     0,     0,     0,    14,   295,
       0,     0,     0,     0,    15,     6,     0,     0,    16,     0,
       0,    17,    18,    19,     0,    20,     8,     9,    10,    11,
      12,     0,     0,     7,    13,     0,     0,     0,    14,   296,
       0,     0,     0,     0,    15,     6,     0,     0,    16,     0,
       0,    17,    18,    19,     0,    20,     0,     0,     8,     9,
      10,    11,    12,     7,     0,     0,    13,     0,     0,     0,
      14,   298,     0,     0,     0,  -171,    15,     0,     0,     0,
      16,     0,     0,    17,    18,    19,     0,    20,     0,     8,
       9,    10,    11,    12,     0,     0,     0,    13,     0,     0,
       0,    14,     0,     0,     0,     6,     0,    15,     0,     0,
       0,    16,     0,     0,    17,    18,    19,     0,    20,     8,
       9,    10,   115,   116,     0,     6,     0,    13,     0,     0,
       0,    14,     0,     0,     0,     0,     0,    15,     0,     0,
       0,    16,     0,     0,    17,    18,    19,     0,    20,  -171,
    -171,  -171,  -171,  -171,     0,     6,     0,  -171,     0,  -171,
       0,  -171,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  -171,  -171,  -171,  -171,  -171,     0,  -171,     8,
       9,    10,    11,    12,     0,     6,     0,    13,     0,     0,
       0,    14,  -231,     0,     0,     0,     0,     0,     0,     8,
       9,    10,    11,    12,    17,    18,    19,    13,    20,     0,
       0,    14,   289,     0,     0,     6,     0,     0,     0,     0,
       0,     0,     0,     0,    17,    18,    19,     0,    20,     8,
       9,    10,    11,    12,     0,     0,     0,    13,     0,     0,
       0,    14,   301,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    17,    18,    19,     0,    20,     8,
       9,    10,    11,    12,   122,     0,     0,    13,   123,     0,
       0,    14,   302,     0,     0,     0,     0,     0,     0,   124,
       0,   125,   126,   127,    17,    18,    19,     0,    20,     8,
       9,    10,    11,    12,   122,   256,     0,    13,   123,   257,
       0,    14,     0,     0,   258,     0,   259,   260,   261,   124,
       0,   125,   126,   127,    17,    18,    19,     0,    20,   262,
     263,   264,   265,   266,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   128,   129,
     130,   131,   132,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   128,   129,
     130,   213,   132,   267,     0,     0,     0,     0,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280
};

static const short yycheck[] =
{
       1,     2,   111,    50,    51,    52,    14,    86,   101,    23,
      28,    14,    14,    14,    61,    12,    37,    38,    39,    20,
      41,    42,    43,    44,    45,    46,    47,    48,    14,    14,
      51,    33,    32,    54,    55,    25,   145,    58,    59,    60,
      32,    15,   121,    64,    29,    30,    76,    68,    69,    70,
      32,   144,    26,     7,    32,     7,    32,    11,    86,    11,
      40,    88,    89,     0,    18,    30,    18,    12,    85,    76,
      32,    32,    32,    53,    85,    88,   103,    57,    20,    88,
      87,    98,    99,    88,    20,     0,     1,    98,    99,    31,
      90,    88,     7,   107,   112,    31,    11,    88,    88,   107,
      88,    16,    89,    18,   106,    20,   109,    80,    84,    82,
      88,    88,   221,   105,    25,    30,    31,    32,    33,    34,
      35,    95,   108,   105,    89,   172,   173,   220,    88,   208,
      88,   133,   179,    88,    88,   182,   110,    32,   103,   186,
     105,    95,    96,    95,    96,   131,    88,    88,   134,   196,
      88,    93,    94,     3,     4,     5,     6,    93,    94,    88,
      75,    76,    77,    78,    79,    88,   140,    88,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    88,    98,    99,   100,   101,   102,   103,   104,
     105,    88,    88,    88,    89,    88,    53,    54,    88,    88,
      88,    88,    88,   250,    89,    88,   253,    88,   103,   210,
     211,     1,   214,    88,    88,    88,    25,    76,    12,    76,
      88,    80,   207,    82,   225,   226,     4,   213,    87,   215,
      87,   203,   182,   186,   253,   237,   238,   239,   250,   179,
     196,   176,   237,   217,   246,     0,     1,    14,   247,   238,
     235,   210,     7,   175,    -1,   239,    11,    -1,    -1,    -1,
      -1,    16,    -1,    18,    -1,    20,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    30,    31,    32,    33,    34,
      35,     1,    -1,    -1,    -1,    75,    76,    77,    78,    79,
     311,    -1,    -1,    83,    -1,    85,    -1,    87,    -1,    19,
      -1,    -1,   303,    -1,    -1,    -1,    -1,    -1,    98,    99,
     100,   101,   102,    -1,   104,    -1,    -1,   318,    -1,    -1,
      75,    76,    77,    78,    79,    -1,    -1,    -1,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    -1,    98,    99,   100,   101,   102,   103,   104,
     105,     0,     1,    -1,    -1,    75,    76,    77,    78,    79,
      -1,    -1,    -1,    83,    -1,    -1,    -1,    87,    -1,    -1,
      19,    -1,    -1,    93,    -1,    -1,    -1,    97,    -1,    -1,
     100,   101,   102,    -1,   104,   105,    -1,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,     0,     1,    -1,    83,    -1,    85,    -1,    87,    -1,
      -1,    -1,    -1,    -1,    93,    16,    -1,    -1,    97,    20,
      19,   100,   101,   102,    -1,   104,    -1,    -1,    -1,    -1,
      31,    -1,    33,    34,    35,    -1,    -1,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    -1,    -1,    -1,    83,    -1,    -1,    -1,    87,     1,
      91,    92,    93,    94,    93,     7,    -1,    -1,    97,    11,
      -1,   100,   101,   102,    16,   104,    18,    19,    20,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    31,
      32,    33,    34,    35,     1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    19,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,     1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    75,    76,    77,    78,    79,    -1,    -1,
      -1,    83,    19,    85,    -1,    87,    88,    -1,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,     1,   104,    -1,    -1,    -1,    -1,    -1,    75,    76,
      77,    78,    79,    -1,    -1,    -1,    83,    -1,    -1,    19,
      87,    88,    -1,    -1,    -1,    -1,    93,    -1,    -1,    -1,
      97,     1,    -1,   100,   101,   102,    -1,   104,    75,    76,
      77,    78,    79,    -1,    -1,    -1,    83,    -1,    -1,    19,
      87,    88,    -1,    -1,    -1,    -1,    93,    -1,    -1,    -1,
      97,    -1,     1,   100,   101,   102,    -1,   104,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    75,    76,    77,    78,    79,
      19,    -1,    -1,    83,    -1,    -1,    -1,    87,    88,    -1,
      -1,    -1,     1,    93,    -1,    -1,    -1,    97,    -1,    -1,
     100,   101,   102,    -1,   104,    75,    76,    77,    78,    79,
      19,    -1,    -1,    83,    -1,    -1,    -1,    87,    88,    -1,
      -1,    -1,    -1,    93,     1,    -1,    -1,    97,    -1,    -1,
     100,   101,   102,    -1,   104,    -1,    75,    76,    77,    78,
      79,    -1,    19,    -1,    83,    -1,    -1,    -1,    87,    88,
      -1,    -1,    -1,    -1,    93,     1,    -1,    -1,    97,    -1,
      -1,   100,   101,   102,    -1,   104,    75,    76,    77,    78,
      79,    -1,    -1,    19,    83,    -1,    -1,    -1,    87,    88,
      -1,    -1,    -1,    -1,    93,     1,    -1,    -1,    97,    -1,
      -1,   100,   101,   102,    -1,   104,    -1,    -1,    75,    76,
      77,    78,    79,    19,    -1,    -1,    83,    -1,    -1,    -1,
      87,    88,    -1,    -1,    -1,     1,    93,    -1,    -1,    -1,
      97,    -1,    -1,   100,   101,   102,    -1,   104,    -1,    75,
      76,    77,    78,    79,    -1,    -1,    -1,    83,    -1,    -1,
      -1,    87,    -1,    -1,    -1,     1,    -1,    93,    -1,    -1,
      -1,    97,    -1,    -1,   100,   101,   102,    -1,   104,    75,
      76,    77,    78,    79,    -1,     1,    -1,    83,    -1,    -1,
      -1,    87,    -1,    -1,    -1,    -1,    -1,    93,    -1,    -1,
      -1,    97,    -1,    -1,   100,   101,   102,    -1,   104,    75,
      76,    77,    78,    79,    -1,     1,    -1,    83,    -1,    85,
      -1,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    98,    99,   100,   101,   102,    -1,   104,    75,
      76,    77,    78,    79,    -1,     1,    -1,    83,    -1,    -1,
      -1,    87,    88,    -1,    -1,    -1,    -1,    -1,    -1,    75,
      76,    77,    78,    79,   100,   101,   102,    83,   104,    -1,
      -1,    87,    88,    -1,    -1,     1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   100,   101,   102,    -1,   104,    75,
      76,    77,    78,    79,    -1,    -1,    -1,    83,    -1,    -1,
      -1,    87,    88,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   100,   101,   102,    -1,   104,    75,
      76,    77,    78,    79,    16,    -1,    -1,    83,    20,    -1,
      -1,    87,    88,    -1,    -1,    -1,    -1,    -1,    -1,    31,
      -1,    33,    34,    35,   100,   101,   102,    -1,   104,    75,
      76,    77,    78,    79,    16,     7,    -1,    83,    20,    11,
      -1,    87,    -1,    -1,    16,    -1,    18,    19,    20,    31,
      -1,    33,    34,    35,   100,   101,   102,    -1,   104,    31,
      32,    33,    34,    35,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    90,    91,
      92,    93,    94,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    90,    91,
      92,    93,    94,    85,    -1,    -1,    -1,    -1,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned char yystos[] =
{
       0,     3,     4,     5,     6,   107,     1,    19,    75,    76,
      77,    78,    79,    83,    87,    93,    97,   100,   101,   102,
     104,   137,   138,   140,   142,   144,   145,   146,   148,   149,
     150,   151,   137,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    85,   108,   109,   110,   137,   108,     0,     7,
      11,    16,    18,    19,    20,    31,    32,    33,    34,    35,
      85,    88,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   137,   139,   140,   141,   142,
     143,   147,   148,   151,   154,    78,    79,   144,   105,   137,
     153,    32,    16,    20,    31,    33,    34,    35,    90,    91,
      92,    93,    94,   139,   141,     7,    11,    18,    95,    96,
     143,   144,    85,    98,    99,   147,   151,   151,    84,   130,
     131,   134,   135,   140,    76,   132,   133,   128,    80,    82,
     129,   129,   129,   128,   129,   129,   129,   129,   129,   129,
     129,   129,    53,    54,    76,    87,   118,   119,   126,   116,
     117,   126,   112,   113,   126,   129,   114,   115,   126,   128,
     129,   129,   128,   129,   129,   129,   124,   125,   126,   129,
     129,   129,   129,    86,    25,    12,   138,   149,    32,    88,
      89,   103,   140,    93,   139,   141,   142,   143,   144,   146,
      99,   147,    88,    88,    30,    89,   103,   105,   138,    12,
     142,   140,   142,    25,   144,   149,   146,    89,    32,    90,
      16,    33,    34,    35,    91,    92,   136,    89,   129,   111,
     122,   123,   126,   120,   121,   126,     7,    11,    16,    18,
      19,    20,    31,    32,    33,    34,    35,    85,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   154,   119,   117,   113,   115,   125,   110,    88,    88,
      88,   153,   137,    88,    88,    88,    88,    88,    88,    88,
      88,    88,    88,   152,   137,   137,   131,   135,   134,   140,
     133,   127,   123,   121,    25,    12,    88,    88,   103,    88,
     137,   105,   129,   137,   105,    88
};

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrlab1

/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)         \
  Current.first_line   = Rhs[1].first_line;      \
  Current.first_column = Rhs[1].first_column;    \
  Current.last_line    = Rhs[N].last_line;       \
  Current.last_column  = Rhs[N].last_column;
#endif

/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)

# define YYDSYMPRINT(Args)			\
do {						\
  if (yydebug)					\
    yysymprint Args;				\
} while (0)

# define YYDSYMPRINTF(Title, Token, Value, Location)		\
do {								\
  if (yydebug)							\
    {								\
      YYFPRINTF (stderr, "%s ", Title);				\
      yysymprint (stderr, 					\
                  Token, Value);	\
      YYFPRINTF (stderr, "\n");					\
    }								\
} while (0)

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (cinluded).                                                   |
`------------------------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_stack_print (short *bottom, short *top)
#else
static void
yy_stack_print (bottom, top)
    short *bottom;
    short *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (/* Nothing. */; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_reduce_print (int yyrule)
#else
static void
yy_reduce_print (yyrule)
    int yyrule;
#endif
{
  int yyi;
  unsigned int yylineno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %u), ",
             yyrule - 1, yylineno);
  /* Print the symbols being reduced, and their result.  */
  for (yyi = yyprhs[yyrule]; 0 <= yyrhs[yyi]; yyi++)
    YYFPRINTF (stderr, "%s ", yytname [yyrhs[yyi]]);
  YYFPRINTF (stderr, "-> %s\n", yytname [yyr1[yyrule]]);
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (Rule);		\
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YYDSYMPRINT(Args)
# define YYDSYMPRINTF(Title, Token, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

#endif /* !YYERROR_VERBOSE */



#if YYDEBUG
/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yysymprint (FILE *yyoutput, int yytype, YYSTYPE *yyvaluep)
#else
static void
yysymprint (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (yytype < YYNTOKENS)
    {
      YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
# ifdef YYPRINT
      YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
    }
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyoutput, ")");
}

#endif /* ! YYDEBUG */
/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yydestruct (int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yytype, yyvaluep)
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  switch (yytype)
    {

      default:
        break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM);
# else
int yyparse ();
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM)
# else
int yyparse (YYPARSE_PARAM)
  void *YYPARSE_PARAM;
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  
  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;



#define YYPOPSTACK   (yyvsp--, yyssp--)

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	short *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YYDSYMPRINTF ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %s, ", yytname[yytoken]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;


  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 4:
#line 148 "qmparse.y"
    { YYACCEPT; }
    break;

  case 7:
#line 152 "qmparse.y"
    { if (pmode != INTERACT && pmode != SOURCE)
				  YYERROR; }
    break;

  case 9:
#line 158 "qmparse.y"
    { shell(); }
    break;

  case 14:
#line 170 "qmparse.y"
    { if (!expression()) YYABORT; }
    break;

  case 17:
#line 177 "qmparse.y"
    { if (!copyright()) YYABORT; }
    break;

  case 18:
#line 180 "qmparse.y"
    {
  char *s;
  if (strparam(yyvsp[0].sval, &s)) {
    list_completions(s);
    free(s);
  } else
    YYABORT;
}
    break;

  case 19:
#line 190 "qmparse.y"
    {
  int res = 1;
  if (checkbrk) YYABORT;
  if (gflag)
    gcmd("q-help-cmd");
  else
    res = help(NULL);
  if (!res) YYABORT;
}
    break;

  case 20:
#line 201 "qmparse.y"
    {
  char *s;
  if (strparam(yyvsp[0].sval, &s)) {
    int res = 1;
    if (gflag) gcmd_s("q-help-cmd", s);
    else
      res = help(s);
    free(s);
    if (!res) YYABORT;
  } else
    YYABORT;
}
    break;

  case 21:
#line 215 "qmparse.y"
    {
  if (checkbrk) YYABORT;
  printstr(qpath);
}
    break;

  case 22:
#line 221 "qmparse.y"
    {
  char *s;
  if (strparam(yyvsp[0].sval, &s) && s) {
    change_qpath(s);
    if (lt_dlsetsearchpath(qpath)) {
      thr->qmstat = MEM_OVF;
      clean();
      YYABORT;
    }
    if (gflag) gcmd_s("q-path-cmd", qpath);
  } else
    YYABORT;
}
    break;

  case 23:
#line 236 "qmparse.y"
    {
  static savepos();
  char **argv = yyvsp[0].aval.v;
  int argc = yyvsp[0].aval.c, i;
  if (argc == 0) {
    free(argv);
    if (checkbrk) YYABORT;
    printstr(prompt);
  } else if (argc > 3) {
    for (i = 0; i < argc; i++) free(argv[i]);
    free(argv);
    savepos();
    thr->qmstat = SYNTAX_ERR;
  } else {
    if (prompt) free(prompt);
    prompt = argv[0];
    if (gflag) gcmd_s("q-prompt-cmd", argv[0]);
    new_xprompt();
    if (argc > 1) prompt2 = argv[1];
    if (argc > 2) prompt3 = argv[2];
    free(argv);
  }
  if (!clean()) YYABORT;
}
    break;

  case 24:
#line 262 "qmparse.y"
    {
  if (checkbrk) YYABORT;
  switch (imode) {
  case 0: printf("dec; "); break;
  case 1: printf("hex; "); break;
  case 2: printf("oct; "); break;
  }
  switch (fmode) {
  case 0: printf("std %d\n", fprec); break;
  case 1: printf("sci %d\n", fprec); break;
  case 2: printf("fix %d\n", fprec); break;
  } 
}
    break;

  case 25:
#line 277 "qmparse.y"
    { if (checkbrk) YYABORT; imode = 0; if (gflag) gcmd("q-dec-cmd"); }
    break;

  case 26:
#line 280 "qmparse.y"
    { if (checkbrk) YYABORT; imode = 1; if (gflag) gcmd("q-hex-cmd"); }
    break;

  case 27:
#line 283 "qmparse.y"
    { if (checkbrk) YYABORT; imode = 2; if (gflag) gcmd("q-oct-cmd"); }
    break;

  case 28:
#line 286 "qmparse.y"
    { 
  if (checkbrk) YYABORT;
  fmode = 0; fprec = 15; sprintf(fformat, STDFORMAT, fprec);
  if (gflag) gcmd_i("q-std-cmd", fprec);
}
    break;

  case 29:
#line 293 "qmparse.y"
    {
  long p;
  if (intparam(yyvsp[0].sval, &p)) {
    if (p >= 0) {
      fmode = 0; fprec = p; sprintf(fformat, STDFORMAT, fprec);
      if (gflag) gcmd_i("q-std-cmd", fprec);
    } else {
      thr->qmstat = BAD_FORMAT;
      clean();
      YYABORT;
    }
  } else
    YYABORT;
}
    break;

  case 30:
#line 309 "qmparse.y"
    { 
  if (checkbrk) YYABORT;
  fmode = 1; fprec = 15; sprintf(fformat, SCIFORMAT, fprec);
  if (gflag) gcmd_i("q-sci-cmd", fprec);
}
    break;

  case 31:
#line 316 "qmparse.y"
    {
  long p;
  if (intparam(yyvsp[0].sval, &p)) {
    if (p >= 0) {
      fmode = 1; fprec = p; sprintf(fformat, SCIFORMAT, fprec);
      if (gflag) gcmd_i("q-sci-cmd", fprec);
    } else {
      thr->qmstat = BAD_FORMAT;
      clean();
      YYABORT;
    }
  } else
    YYABORT;
}
    break;

  case 32:
#line 332 "qmparse.y"
    { 
  if (checkbrk) YYABORT;
  fmode = 2; fprec = 2; sprintf(fformat, FIXFORMAT, fprec);
  if (gflag) gcmd_i("q-fix-cmd", fprec);
}
    break;

  case 33:
#line 339 "qmparse.y"
    {
  long p;
  if (intparam(yyvsp[0].sval, &p)) {
    if (p >= 0) {
      fmode = 2; fprec = p; sprintf(fformat, FIXFORMAT, fprec);
      if (gflag) gcmd_i("q-fix-cmd", fprec);
    } else {
      thr->qmstat = BAD_FORMAT;
      clean();
      YYABORT;
    }
  } else
    YYABORT;
}
    break;

  case 34:
#line 355 "qmparse.y"
    {
  if (checkbrk) YYABORT;
#ifndef USE_READLINE
  histwarn();
#endif
  printstr(histfile);
}
    break;

  case 35:
#line 364 "qmparse.y"
    {
  char *s;
  if (strparam(yyvsp[0].sval, &s)) {
    sethistfile(s);
    if (gflag) gcmd_s("q-histfile-cmd", s);
  } else
    YYABORT;
}
    break;

  case 36:
#line 374 "qmparse.y"
    {
  if (checkbrk) YYABORT;
#ifndef USE_READLINE
  histwarn();
#endif
  printf("%d\n", histmax);
}
    break;

  case 37:
#line 383 "qmparse.y"
    {
  long i;
  if (intparam(yyvsp[0].sval, &i)) {
    sethistsize(i);
    if (gflag) gcmd_i("q-histsize-cmd", i);
  } else
    YYABORT;
}
    break;

  case 38:
#line 393 "qmparse.y"
    {
  if (checkbrk) YYABORT;
  printf("%d\n", stackmax);
}
    break;

  case 39:
#line 399 "qmparse.y"
    {
  long i;
  if (intparam(yyvsp[0].sval, &i)) {
    if (i == 0 || i >= STACKMIN) {
      stackmax = i;
    } else {
      printf("bad stack size %d, using default\n", i);
      stackmax = STACKMAX;
    }
    if (gflag) gcmd_i("q-stacksize-cmd", stackmax);
    /* this is needed to have the stack resized properly */
    clean();
  } else
    YYABORT;
}
    break;

  case 40:
#line 416 "qmparse.y"
    {
  if (checkbrk) YYABORT;
  printf("%d\n", memmax);
}
    break;

  case 41:
#line 422 "qmparse.y"
    {
  long i;
  if (intparam(yyvsp[0].sval, &i)) {
    if (i == 0 || i >= MEMMIN) {
      memmax = i;
    } else {
      printf("bad memory size %d, using default\n", i);
      memmax = MEMMAX;
    }
    lastblksz = memmax % XBLKSZ;
    maxnblks = memmax/XBLKSZ+((memmax <= 0||lastblksz==0)?0:1);
    if (lastblksz == 0) lastblksz = XBLKSZ;
    if (gflag) gcmd_i("q-memsize-cmd", memmax);
  } else
    YYABORT;
}
    break;

  case 42:
#line 440 "qmparse.y"
    { if (checkbrk) YYABORT; print_stats(0); }
    break;

  case 43:
#line 443 "qmparse.y"
    { if (allparam(yyvsp[0].sval)) print_stats(1); else YYABORT; }
    break;

  case 44:
#line 446 "qmparse.y"
    {
  char wd[MAXSTRLEN];
  if (checkbrk) YYABORT;
  if (getcwd(wd, MAXSTRLEN)) {
    printstr(wd);
  } else {
    thr->qmstat = MEM_OVF;
    clean();
    YYABORT;
  }
}
    break;

  case 45:
#line 459 "qmparse.y"
    {
  char buf[MAXSTRLEN];
  if (checkbrk) YYABORT;
  if (chdir(expand(buf, "~"))) {
    thr->qmstat = BAD_DIR;
    clean();
    YYABORT;
  } else {
    if (gflag) gcmd_s("q-cd-cmd", buf);
    new_xprompt();
  }
}
    break;

  case 46:
#line 473 "qmparse.y"
    {
  char *s;
  if (strparam(yyvsp[0].sval, &s)) {
    int res;
    char *buf =
      malloc((MAXSTRLEN+strlen(s)+1)*
	     sizeof(char));
    if (buf)
      expand(buf, s);
    else
      thr->qmstat = MEM_OVF;
    free(s);
    res = clean();
    if (res && buf)
      if (chdir(buf)) {
	thr->qmstat = BAD_DIR;
	res = clean();
      } else {
	if (gflag) gcmd_s("q-cd-cmd", buf);
	new_xprompt();
      }
    if (buf) free(buf);
    if (!res) YYABORT;
  } else
    YYABORT;
}
    break;

  case 47:
#line 502 "qmparse.y"
    {
  static char ls_cmd[] = "ls";
  char **argv = yyvsp[0].aval.v, *cmd;
  int argc = yyvsp[0].aval.c, l = 0, i;
  for (i = 0; i < argc; i++)
    l += strlen(argv[i])+1;
  if (!(cmd = (char*)malloc((strlen(ls_cmd)+l+1)*sizeof(char))))
    thr->qmstat = MEM_OVF;
  else {
    strcpy(cmd, ls_cmd);
    for (i = 0; i < argc; i++)
      strcat(strcat(cmd, " "), argv[i]);
    push_sigint(SIG_DFL);
    system(cmd);
    pop_sigint();
    free(cmd);
  }
  for (i = 0; i < argc; i++) free(argv[i]);
  free(argv);
  if (!clean()) YYABORT;
}
    break;

  case 48:
#line 526 "qmparse.y"
    {
  extern int debug_parse_opts(char*);
  extern char *debug_get_opts(char*);
  char **argv = yyvsp[0].aval.v, *cmd;
  int argc = yyvsp[0].aval.c, l = 0, i;
  if (!argc) {
    free(argv);
    if (checkbrk) YYABORT;
    printf("debug is %s\n", debug?"on":"off");
  } else if (argc ==1 && (!strcmp(argv[0],"on") || !strcmp(argv[0],"off"))) {
    int b = !strcmp(argv[0],"on");
    for (i = 0; i < argc; i++) free(argv[i]);
    free(argv);
    debug = thr->debug = b;
    if (gflag) gcmd_b("q-debug-cmd", b);
  } else {
    for (i = 0; i < argc; i++)
      l += strlen(argv[i])+1;
    if (!(cmd = (char*)malloc((l+1)*sizeof(char))))
      thr->qmstat = MEM_OVF;
    else {
      *cmd = 0;
      for (i = 0; i < argc; i++) {
	if (i > 0) strcat(cmd, " ");
	strcat(cmd, argv[i]);
      }
      if (!debug_parse_opts(cmd))
	thr->qmstat = SYNTAX_ERR;
      else if (gflag) {
	char opts[MAXSTRLEN];
	gcmd_s("q-debug-options-cmd", debug_get_opts(opts));
      }
      free(cmd);
    }
    for (i = 0; i < argc; i++) free(argv[i]);
    free(argv);
    if (!clean()) YYABORT;
  }
}
    break;

  case 49:
#line 567 "qmparse.y"
    {
  if (checkbrk) YYABORT;
  breakpoints();
}
    break;

  case 50:
#line 573 "qmparse.y"
    {
  int b;
  if (boolparam(yyvsp[0].sval, &b)) {
    brkdbg = thr->brkdbg = b;
    if (gflag) gcmd_b("q-break-cmd", b);
  } else
    YYABORT;
}
    break;

  case 53:
#line 587 "qmparse.y"
    {
  if (checkbrk) YYABORT;
  profile();
}
    break;

  case 55:
#line 595 "qmparse.y"
    {
  if (checkbrk) YYABORT;
  clear_vars();
}
    break;

  case 56:
#line 601 "qmparse.y"
    {
  int i;
  if (checkbrk) YYABORT;
  for (i = RESERVED; i < symtbsz+tmptbsz; i++) {
    if (symtb[i].flags & BRK) {
      symtb[i].flags &= ~BRK;
      nbreak--;
    }
    if (symtb[i].flags & TBRK) {
      symtb[i].flags &= ~TBRK;
      nbreak--;
    }
  }
}
    break;

  case 57:
#line 617 "qmparse.y"
    {
  int i;
  if (checkbrk) YYABORT;
  for (i = RESERVED; i < symtbsz+tmptbsz; i++) {
    if (symtb[i].flags & PROF) {
      symtb[i].flags &= ~PROF;
      symtb[i].nredns = 0;
      nprof--;
    }
  }
}
    break;

  case 61:
#line 636 "qmparse.y"
    {
  if (checkbrk) YYABORT;
  printf("echo is %s\n", eflag?"on":"off");
}
    break;

  case 62:
#line 642 "qmparse.y"
    {
  int b; char *s;
  if (boolstrparam(yyvsp[0].sval, &b, &s))
    if (!s) {
      eflag = b;
      if (gflag) gcmd_b("q-echo-cmd", b);
    } else {
      printf("%s\n", s);
      free(s);
    }
  else
    YYABORT;
}
    break;

  case 63:
#line 657 "qmparse.y"
    {
  if (checkbrk) YYABORT;
  printstr(which);
}
    break;

  case 64:
#line 663 "qmparse.y"
    {
  char *s;
  if (strparam(yyvsp[0].sval, &s)) {
    int l0 = strlen(s), l = strlen(qpath)+l0;
    char *buf = malloc((l+3)*sizeof(char));
    char *name = malloc((l+MAXSTRLEN+3)*sizeof(char));
    if (buf && name) {
      absname(name, searchlib(buf, s));
      if (!chkfile(name)) {
	char *t = malloc((l0+3)*sizeof(char));
	if (!t) goto errexit;
	strcat(strcpy(t, s), ".q");
	absname(name, searchlib(buf, t));
	free(t);
      }
      if (chkfile(name))
	printstr(name);
      else
	printf("%s not found\n", s);
    } else {
    errexit:
      thr->qmstat = MEM_OVF;
    }
    clean();
    free(s);
    if (buf) free(buf);
    if (name) free(name);
  } else
    YYABORT;
}
    break;

  case 65:
#line 695 "qmparse.y"
    {
  if (checkbrk) YYABORT;
  if (gflag)
    gcmd_s("q-edit-cmd", which);
  else if (!edit(which))
    YYABORT;
}
    break;

  case 66:
#line 704 "qmparse.y"
    {
  char *s;
  if (strparam(yyvsp[0].sval, &s)) {
    int res;
    char *buf = malloc((MAXSTRLEN+strlen(s)+1)*sizeof(char));
    if (buf) {
      expand(buf, s);
      if (gflag)
	gcmd_s("q-edit-cmd", buf);
      else
	edit(buf);
    } else
      thr->qmstat = MEM_OVF;
    res = clean();
    free(s); if (buf) free(buf);
    if (!res) YYABORT;
  } else
    YYABORT;
}
    break;

  case 67:
#line 725 "qmparse.y"
    {
  char *s;
  if (strparam(yyvsp[0].sval, &s)) {
    int l = strlen(qpath)+strlen(s);
    char *buf = malloc((l+1)*sizeof(char));
    if (buf) {
      int res = parsesrc(searchlib(buf, s), 1);
      if (!res) {
	free(buf);
	free(s);
	YYABORT;
      }
    } else
      thr->qmstat = MEM_OVF;
    free(s);
    if (buf) free(buf);
    if (!clean())
      YYABORT;
  } else
    YYABORT;
}
    break;

  case 68:
#line 748 "qmparse.y"
    {
  if (checkbrk) YYABORT;
  if (!save_file)
    save_file = strdup(".q_vars");
  if (!save_file) {
    thr->qmstat = MEM_OVF;
    clean();
    YYABORT;
  }
  if (chkfile(save_file)) {
    int _eflag = eflag, res;
    printf("loading ");
    printstr(save_file);
    eflag = 0;
    res = parsesrc(save_file, 0);
    eflag = _eflag;
    if (!res) YYABORT;
  }
}
    break;

  case 69:
#line 769 "qmparse.y"
    {
  char *s;
  if (strparam(yyvsp[0].sval, &s)) {
    char *buf = malloc((strlen(s)+MAXSTRLEN+1)*sizeof(char));
    if (buf) {
      int _eflag = eflag, res;
      eflag = 0;
      res = parsesrc(expand(buf, s), 0);
      eflag = _eflag;
      if (res) {
	if (save_file) free(save_file);
	save_file = buf;
      } else {
	free(buf);
	free(s);
	YYABORT;
      }
    } else
      thr->qmstat = MEM_OVF;
    free(s);
    if (!clean())
      YYABORT;
  } else
    YYABORT;
}
    break;

  case 70:
#line 796 "qmparse.y"
    {
  if (checkbrk) YYABORT;
  if (!save_file)
    save_file = strdup(".q_vars");
  if (!save_file) {
    thr->qmstat = MEM_OVF;
    clean();
    YYABORT;
  }
  printf("saving ");
  printstr(save_file);
  if (!save_vars(NULL)) YYABORT;
}
    break;

  case 71:
#line 811 "qmparse.y"
    {
  char *s;
  if (strparam(yyvsp[0].sval, &s)) {
    int res;
    char *buf = malloc((strlen(s)+MAXSTRLEN+1)*sizeof(char));
    if (buf) {
      res = save_vars(expand(buf, s));
      if (!res)	free(buf);
    } else {
      thr->qmstat = MEM_OVF;
      res = 0;
    }
    free(s);
    if (!res) YYABORT;
  } else
    YYABORT;
}
    break;

  case 72:
#line 830 "qmparse.y"
    {
  char **argv = yyvsp[0].aval.v;
  int count = 0, i, argc = yyvsp[0].aval.c;
  if (argv && argc > 0) {
    for (i = 0; i < argc; i++) {
      int res;
      if (*argv[i] == '-')
	res = del_import(argv[i]+1);
      else if (*argv[i] == '+')
	res = add_import(strdup(argv[i]+1));
      else
	res = add_import(strdup(argv[i]));
      if (res) count++;
      free(argv[i]);
    }
    free(argv);
    if (count)
      rerun(NULL, 0, NULL);
  } else if (clear_imports())
    rerun(NULL, 0, NULL);
}
    break;

  case 73:
#line 853 "qmparse.y"
    { if (!import_list()) YYABORT; }
    break;

  case 74:
#line 856 "qmparse.y"
    { if (!modules()) YYABORT; }
    break;

  case 75:
#line 859 "qmparse.y"
    { if (!who(0)) YYABORT; }
    break;

  case 76:
#line 862 "qmparse.y"
    { if (!allparam(yyvsp[0].sval) || !who(1)) YYABORT; }
    break;

  case 78:
#line 867 "qmparse.y"
    { if (checkbrk) YYABORT; rerun(NULL, 0, NULL); }
    break;

  case 79:
#line 870 "qmparse.y"
    {
  char *s;
  if (strparam(yyvsp[0].sval, &s)) {
    yyval.aval.v = (char**)malloc((MAXARGC+1)*sizeof(char*));
    if (!yyval.aval.v) {
      thr->qmstat = MEM_OVF;
      clean();
      YYABORT;
    }
    yyval.aval.v[0] = s;
    yyval.aval.c = 1;
  } else
    YYABORT;
}
    break;

  case 80:
#line 885 "qmparse.y"
    {
  char **argv = yyvsp[0].aval.v;
  int argc = yyvsp[0].aval.c, ret;
  argv[argc] = NULL;
  ret = rerun(*argv, argc, argv);
  while (argc > 0)
    if (argv[argc-1]) free(argv[--argc]);
  if (argv) free(argv);
  if (!ret) YYABORT;
}
    break;

  case 83:
#line 900 "qmparse.y"
    {
  if (checkbrk) YYABORT;
  savepos();
  if (!(symtb[yyvsp[0].ival].flags&VSYM)) {
    if (symtb[yyvsp[0].ival].flags & TBRK) {
      symtb[yyvsp[0].ival].flags &= ~TBRK;
      nbreak--;
    }
    if (!(symtb[yyvsp[0].ival].flags & BRK)) {
      symtb[yyvsp[0].ival].flags |= BRK;
      nbreak++;
    }
    if (!brkdbg || !thr->brkdbg) {
      brkdbg = thr->brkdbg = 1;
      if (gflag) gcmd_b("q-break-cmd", 1);
    }
  } else {
    thr->qmstat = BAD_SYM;
    clean();
    YYABORT;
  }
}
    break;

  case 86:
#line 927 "qmparse.y"
    {
  if (checkbrk) YYABORT;
  savepos();
  if (!(symtb[yyvsp[0].ival].flags&VSYM)) {
    if (symtb[yyvsp[0].ival].flags & BRK) {
      symtb[yyvsp[0].ival].flags &= ~BRK;
      nbreak--;
    }
    if (!(symtb[yyvsp[0].ival].flags & TBRK)) {
      symtb[yyvsp[0].ival].flags |= TBRK;
      nbreak++;
    }
    if (!brkdbg || !thr->brkdbg) {
      brkdbg = thr->brkdbg = 1;
      if (gflag) gcmd_b("q-break-cmd", 1);
    }
  } else {
    thr->qmstat = BAD_SYM;
    clean();
    YYABORT;
  }
}
    break;

  case 89:
#line 954 "qmparse.y"
    {
  if (checkbrk) YYABORT;
  savepos();
  if (!(symtb[yyvsp[0].ival].flags&VSYM)) {
    if (!(symtb[yyvsp[0].ival].flags & PROF)) {
      symtb[yyvsp[0].ival].flags |= PROF;
      symtb[yyvsp[0].ival].nredns = 0;
      nprof++;
    }
  } else {
    thr->qmstat = BAD_SYM;
    clean();
    YYABORT;
  }
}
    break;

  case 92:
#line 974 "qmparse.y"
    {
  if (checkbrk) YYABORT;
  savepos();
  if (!(symtb[yyvsp[0].ival].flags & VSYM)) {
    thr->qmstat = BAD_SYM;
    clean();
    YYABORT;
  } else if (!unassignment(yyvsp[0].ival))
    YYABORT; 
}
    break;

  case 95:
#line 989 "qmparse.y"
    {
  if (checkbrk) YYABORT;
  savepos();
  if (!(symtb[yyvsp[0].ival].flags & VSYM)) {
    if (symtb[yyvsp[0].ival].flags & BRK) {
      symtb[yyvsp[0].ival].flags &= ~BRK;
      nbreak--;
    }
    if (symtb[yyvsp[0].ival].flags & TBRK) {
      symtb[yyvsp[0].ival].flags &= ~TBRK;
      nbreak--;
    }
  } else {
    thr->qmstat = BAD_SYM;
    clean();
    YYABORT;
  }
}
    break;

  case 98:
#line 1012 "qmparse.y"
    {
  if (checkbrk) YYABORT;
  savepos();
  if (!(symtb[yyvsp[0].ival].flags & VSYM)) {
    if (symtb[yyvsp[0].ival].flags & PROF) {
      symtb[yyvsp[0].ival].flags &= ~PROF;
      symtb[yyvsp[0].ival].nredns = 0;
      nprof--;
    }
  } else {
    thr->qmstat = BAD_SYM;
    clean();
    YYABORT;
  }
}
    break;

  case 101:
#line 1031 "qmparse.y"
    { if (checkbrk) YYABORT; whos(yyvsp[0].ival); }
    break;

  case 103:
#line 1033 "qmparse.y"
    { yyval.ival = yyvsp[-1].ival; }
    break;

  case 104:
#line 1038 "qmparse.y"
    {
  yyval.aval = yyvsp[0].aval;
}
    break;

  case 105:
#line 1044 "qmparse.y"
    {
  char *s;
  if (yyvsp[-1].aval.c >= MAXARGC) {
    thr->qmstat = ARGS_ERR;
    while (yyvsp[-1].aval.c > 0)
      free(yyvsp[-1].aval.v[--yyvsp[-1].aval.c]);
    free(yyvsp[-1].aval.v);
    clean();
    YYABORT;
  } else if (strparam(yyvsp[0].sval, &s))
    yyvsp[-1].aval.v[yyvsp[-1].aval.c++] = s;
  else {
    while (yyvsp[-1].aval.c > 0)
      free(yyvsp[-1].aval.v[--yyvsp[-1].aval.c]);
    free(yyvsp[-1].aval.v);
    YYABORT;
  }
  yyval.aval = yyvsp[-1].aval;
}
    break;

  case 106:
#line 1068 "qmparse.y"
    {
  if (checkbrk) YYABORT;
  yyval.aval.v = (char**)malloc((MAXARGC+1)*sizeof(char*));
  if (!yyval.aval.v) {
    thr->qmstat = MEM_OVF;
    clean();
    YYABORT;
  }
  yyval.aval.c = 0;
}
    break;

  case 107:
#line 1081 "qmparse.y"
    {
  char *s;
  if (yyvsp[-1].aval.c >= MAXARGC) {
    thr->qmstat = ARGS_ERR;
    while (yyvsp[-1].aval.c > 0)
      free(yyvsp[-1].aval.v[--yyvsp[-1].aval.c]);
    free(yyvsp[-1].aval.v);
    clean();
    YYABORT;
  } else if (strparam(yyvsp[0].sval, &s))
    yyvsp[-1].aval.v[yyvsp[-1].aval.c++] = s;
  else {
    while (yyvsp[-1].aval.c > 0)
      free(yyvsp[-1].aval.v[--yyvsp[-1].aval.c]);
    free(yyvsp[-1].aval.v);
    YYABORT;
  }
  yyval.aval = yyvsp[-1].aval;
}
    break;

  case 109:
#line 1104 "qmparse.y"
    { YYERROR; }
    break;

  case 112:
#line 1112 "qmparse.y"
    { if (!assignment()) YYABORT; }
    break;

  case 115:
#line 1120 "qmparse.y"
    { if (!unassignment(yyvsp[0].ival)) YYABORT; }
    break;

  case 117:
#line 1125 "qmparse.y"
    { if (!pushbin(SEQOP)) YYABORT; }
    break;

  case 119:
#line 1130 "qmparse.y"
    { if (!pushbin(yyvsp[-1].ival)) YYABORT; }
    break;

  case 120:
#line 1133 "qmparse.y"
    { yyval.ival = LEOP; }
    break;

  case 121:
#line 1134 "qmparse.y"
    { yyval.ival = GROP; }
    break;

  case 122:
#line 1135 "qmparse.y"
    { yyval.ival = LEQOP; }
    break;

  case 123:
#line 1136 "qmparse.y"
    { yyval.ival = GEQOP; }
    break;

  case 124:
#line 1137 "qmparse.y"
    { yyval.ival = NEQOP; }
    break;

  case 125:
#line 1138 "qmparse.y"
    { yyval.ival = INOP; }
    break;

  case 127:
#line 1143 "qmparse.y"
    { if (!pushbin(SEQOP)) YYABORT; }
    break;

  case 129:
#line 1148 "qmparse.y"
    { if (!pushbin(yyvsp[-1].ival)) YYABORT; }
    break;

  case 130:
#line 1151 "qmparse.y"
    { yyval.ival = LEOP; }
    break;

  case 131:
#line 1152 "qmparse.y"
    { yyval.ival = GROP; }
    break;

  case 132:
#line 1153 "qmparse.y"
    { yyval.ival = EQOP; }
    break;

  case 133:
#line 1154 "qmparse.y"
    { yyval.ival = LEQOP; }
    break;

  case 134:
#line 1155 "qmparse.y"
    { yyval.ival = GEQOP; }
    break;

  case 135:
#line 1156 "qmparse.y"
    { yyval.ival = NEQOP; }
    break;

  case 136:
#line 1157 "qmparse.y"
    { yyval.ival = INOP; }
    break;

  case 138:
#line 1162 "qmparse.y"
    { if (!pushbin(yyvsp[-1].ival)) YYABORT; }
    break;

  case 139:
#line 1164 "qmparse.y"
    { if (!pushbin(MINOP)) YYABORT; }
    break;

  case 140:
#line 1167 "qmparse.y"
    { yyval.ival = ADDOP; }
    break;

  case 141:
#line 1168 "qmparse.y"
    { yyval.ival = CATOP; }
    break;

  case 142:
#line 1169 "qmparse.y"
    { yyval.ival = OROP; }
    break;

  case 143:
#line 1170 "qmparse.y"
    { yyval.ival = ORELSEOP; }
    break;

  case 145:
#line 1175 "qmparse.y"
    { if (!pushbin(yyvsp[-1].ival)) YYABORT; }
    break;

  case 146:
#line 1178 "qmparse.y"
    { yyval.ival = MULOP; }
    break;

  case 147:
#line 1179 "qmparse.y"
    { yyval.ival = FDIVOP; }
    break;

  case 148:
#line 1180 "qmparse.y"
    { yyval.ival = DIVOP; }
    break;

  case 149:
#line 1181 "qmparse.y"
    { yyval.ival = MODOP; }
    break;

  case 150:
#line 1182 "qmparse.y"
    { yyval.ival = ANDOP; }
    break;

  case 151:
#line 1183 "qmparse.y"
    { yyval.ival = ANDTHENOP; }
    break;

  case 153:
#line 1189 "qmparse.y"
    { mpz_neg(yyvsp[0].zval, yyvsp[0].zval);
		                  if (!pushmpz(thr, yyvsp[0].zval)) YYABORT; }
    break;

  case 154:
#line 1191 "qmparse.y"
    { if (!pushfloat(thr, -yyvsp[0].fval)) YYABORT; }
    break;

  case 155:
#line 1192 "qmparse.y"
    { if (!pushun(UMINOP)) YYABORT; }
    break;

  case 156:
#line 1193 "qmparse.y"
    { if (!pushun(yyvsp[-1].ival)) YYABORT; }
    break;

  case 157:
#line 1196 "qmparse.y"
    { yyval.ival = HASHOP; }
    break;

  case 158:
#line 1197 "qmparse.y"
    { yyval.ival = NOTOP; }
    break;

  case 160:
#line 1202 "qmparse.y"
    { if (!pushbin(yyvsp[-1].ival)) YYABORT; }
    break;

  case 161:
#line 1205 "qmparse.y"
    { yyval.ival = POWOP; }
    break;

  case 162:
#line 1206 "qmparse.y"
    { yyval.ival = IDXOP; }
    break;

  case 164:
#line 1211 "qmparse.y"
    { if (!pushbin(COMPOP)) YYABORT; }
    break;

  case 166:
#line 1216 "qmparse.y"
    { if (!pushfun(thr, APPOP)) YYABORT; }
    break;

  case 167:
#line 1219 "qmparse.y"
    { yyval.ival = QUOTEOP; }
    break;

  case 168:
#line 1220 "qmparse.y"
    { yyval.ival = UNQUOTEOP; }
    break;

  case 169:
#line 1221 "qmparse.y"
    { yyval.ival = FORCEOP; }
    break;

  case 170:
#line 1227 "qmparse.y"
    { if (!pushmpz(thr, yyvsp[0].zval)) YYABORT; }
    break;

  case 171:
#line 1228 "qmparse.y"
    { if (!pushfloat(thr, yyvsp[0].fval)) YYABORT; }
    break;

  case 172:
#line 1229 "qmparse.y"
    { if (!pushstr(thr, yyvsp[0].sval)) YYABORT; }
    break;

  case 173:
#line 1230 "qmparse.y"
    { YYERROR; }
    break;

  case 174:
#line 1234 "qmparse.y"
    { if (yyvsp[0].ival == NONE) { YYABORT; }
				  else if (!pushfun(thr, yyvsp[0].ival)) YYABORT; }
    break;

  case 175:
#line 1236 "qmparse.y"
    { if (!pushfun(thr, yyvsp[-1].ival)) YYABORT; }
    break;

  case 176:
#line 1240 "qmparse.y"
    { thr->qmstat = BAD_OBJ; YYABORT; }
    break;

  case 177:
#line 1245 "qmparse.y"
    { if (!pushun(yyvsp[-1].ival)) YYABORT; }
    break;

  case 178:
#line 1250 "qmparse.y"
    { if (!pushun(SEQOP)) YYABORT; }
    break;

  case 179:
#line 1253 "qmparse.y"
    { if (!(pushfun(thr, FLIPOP) && pushfun(thr, SEQOP) &&
					pushfun(thr, APPOP) && swap() &&
					pushfun(thr, APPOP))) YYABORT; }
    break;

  case 180:
#line 1258 "qmparse.y"
    { if (!pushun(yyvsp[-1].ival)) YYABORT; }
    break;

  case 181:
#line 1261 "qmparse.y"
    { if (!(pushfun(thr, FLIPOP) && pushfun(thr, yyvsp[-2].ival) &&
					pushfun(thr, APPOP) && swap() &&
					pushfun(thr, APPOP))) YYABORT; }
    break;

  case 182:
#line 1266 "qmparse.y"
    { if (!pushun(yyvsp[-1].ival)) YYABORT; }
    break;

  case 183:
#line 1269 "qmparse.y"
    { if (!pushun(MINOP)) YYABORT; }
    break;

  case 184:
#line 1272 "qmparse.y"
    { if (!(pushfun(thr, FLIPOP) && pushfun(thr, yyvsp[-2].ival) &&
					pushfun(thr, APPOP) && swap() &&
					pushfun(thr, APPOP))) YYABORT; }
    break;

  case 185:
#line 1277 "qmparse.y"
    { if (!pushun(yyvsp[-1].ival)) YYABORT; }
    break;

  case 186:
#line 1280 "qmparse.y"
    { if (!(pushfun(thr, FLIPOP) && pushfun(thr, yyvsp[-2].ival) &&
					pushfun(thr, APPOP) && swap() &&
					pushfun(thr, APPOP))) YYABORT; }
    break;

  case 187:
#line 1285 "qmparse.y"
    { if (!pushun(yyvsp[-1].ival)) YYABORT; }
    break;

  case 188:
#line 1288 "qmparse.y"
    { if (!(pushfun(thr, FLIPOP) && pushfun(thr, yyvsp[-2].ival) &&
					pushfun(thr, APPOP) && swap() &&
					pushfun(thr, APPOP))) YYABORT; }
    break;

  case 189:
#line 1293 "qmparse.y"
    { if (!pushun(COMPOP)) YYABORT; }
    break;

  case 190:
#line 1296 "qmparse.y"
    { if (!(pushfun(thr, FLIPOP) &&
					pushfun(thr, COMPOP) &&
					pushfun(thr, APPOP) && swap() &&
					pushfun(thr, APPOP))) YYABORT; }
    break;

  case 191:
#line 1304 "qmparse.y"
    { if (!pushfun(thr, VOIDOP)) YYABORT; }
    break;

  case 192:
#line 1306 "qmparse.y"
    { if (!pushfun(thr, VOIDOP) ||
				      !pushfun(thr, PAIROP)) YYABORT; }
    break;

  case 194:
#line 1310 "qmparse.y"
    { if (!pushfun(thr, PAIROP)) YYABORT; }
    break;

  case 195:
#line 1312 "qmparse.y"
    { if (!pushfun(thr, VOIDOP) ||
				      !pushtuple(yyvsp[-1].ival+2)) YYABORT; }
    break;

  case 196:
#line 1315 "qmparse.y"
    { if (!pushtuple(yyvsp[-3].ival+2)) YYABORT; }
    break;

  case 197:
#line 1320 "qmparse.y"
    { if (!pushfun(thr, NILOP)) YYABORT; }
    break;

  case 198:
#line 1322 "qmparse.y"
    { if (!pushfun(thr, NILOP) ||
				      !pushlist(yyvsp[-1].ival+1)) YYABORT; }
    break;

  case 199:
#line 1325 "qmparse.y"
    { if (!pushlist(yyvsp[-3].ival+1)) YYABORT; }
    break;

  case 200:
#line 1327 "qmparse.y"
    { if (!pushfun(thr, NILOP) ||
				      !pushlist(yyvsp[-1].ival+1)) YYABORT; }
    break;

  case 201:
#line 1330 "qmparse.y"
    { if (!pushbin(ENUMOP)) YYABORT; }
    break;

  case 202:
#line 1333 "qmparse.y"
    { YYABORT; }
    break;

  case 203:
#line 1341 "qmparse.y"
    { yyval.ival = 1; }
    break;

  case 204:
#line 1343 "qmparse.y"
    { yyval.ival = yyvsp[-2].ival+1; }
    break;

  case 205:
#line 1346 "qmparse.y"
    { yyval.ival = SEQOP; }
    break;

  case 206:
#line 1347 "qmparse.y"
    { yyval.ival = LEOP; }
    break;

  case 207:
#line 1348 "qmparse.y"
    { yyval.ival = GROP; }
    break;

  case 208:
#line 1349 "qmparse.y"
    { yyval.ival = EQOP; }
    break;

  case 209:
#line 1350 "qmparse.y"
    { yyval.ival = LEQOP; }
    break;

  case 210:
#line 1351 "qmparse.y"
    { yyval.ival = GEQOP; }
    break;

  case 211:
#line 1352 "qmparse.y"
    { yyval.ival = NEQOP; }
    break;

  case 212:
#line 1353 "qmparse.y"
    { yyval.ival = INOP; }
    break;

  case 213:
#line 1354 "qmparse.y"
    { yyval.ival = CATOP; }
    break;

  case 214:
#line 1355 "qmparse.y"
    { yyval.ival = ADDOP; }
    break;

  case 215:
#line 1356 "qmparse.y"
    { yyval.ival = MINOP; }
    break;

  case 216:
#line 1357 "qmparse.y"
    { yyval.ival = OROP; }
    break;

  case 217:
#line 1358 "qmparse.y"
    { yyval.ival = ORELSEOP; }
    break;

  case 218:
#line 1359 "qmparse.y"
    { yyval.ival = MULOP; }
    break;

  case 219:
#line 1360 "qmparse.y"
    { yyval.ival = FDIVOP; }
    break;

  case 220:
#line 1361 "qmparse.y"
    { yyval.ival = DIVOP; }
    break;

  case 221:
#line 1362 "qmparse.y"
    { yyval.ival = MODOP; }
    break;

  case 222:
#line 1363 "qmparse.y"
    { yyval.ival = ANDOP; }
    break;

  case 223:
#line 1364 "qmparse.y"
    { yyval.ival = ANDTHENOP; }
    break;

  case 224:
#line 1365 "qmparse.y"
    { yyval.ival = HASHOP; }
    break;

  case 225:
#line 1366 "qmparse.y"
    { yyval.ival = NOTOP; }
    break;

  case 226:
#line 1367 "qmparse.y"
    { yyval.ival = QUOTEOP; }
    break;

  case 227:
#line 1368 "qmparse.y"
    { yyval.ival = UNQUOTEOP; }
    break;

  case 228:
#line 1369 "qmparse.y"
    { yyval.ival = FORCEOP; }
    break;

  case 229:
#line 1370 "qmparse.y"
    { yyval.ival = POWOP; }
    break;

  case 230:
#line 1371 "qmparse.y"
    { yyval.ival = IDXOP; }
    break;

  case 231:
#line 1372 "qmparse.y"
    { yyval.ival = COMPOP; }
    break;


    }

/* Line 991 of yacc.c.  */
#line 3342 "qmparse.c"

  yyvsp -= yylen;
  yyssp -= yylen;


  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  int yytype = YYTRANSLATE (yychar);
	  char *yymsg;
	  int yyx, yycount;

	  yycount = 0;
	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  for (yyx = yyn < 0 ? -yyn : 0;
	       yyx < (int) (sizeof (yytname) / sizeof (char *)); yyx++)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      yysize += yystrlen (yytname[yyx]) + 15, yycount++;
	  yysize += yystrlen ("syntax error, unexpected ") + 1;
	  yysize += yystrlen (yytname[yytype]);
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "syntax error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[yytype]);

	      if (yycount < 5)
		{
		  yycount = 0;
		  for (yyx = yyn < 0 ? -yyn : 0;
		       yyx < (int) (sizeof (yytname) / sizeof (char *));
		       yyx++)
		    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
		      {
			const char *yyq = ! yycount ? ", expecting " : " or ";
			yyp = yystpcpy (yyp, yyq);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yycount++;
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("syntax error; also virtual memory exhausted");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror ("syntax error");
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      /* Return failure if at end of input.  */
      if (yychar == YYEOF)
        {
	  /* Pop the error token.  */
          YYPOPSTACK;
	  /* Pop the rest of the stack.  */
	  while (yyss < yyssp)
	    {
	      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
	      yydestruct (yystos[*yyssp], yyvsp);
	      YYPOPSTACK;
	    }
	  YYABORT;
        }

      YYDSYMPRINTF ("Error: discarding", yytoken, &yylval, &yylloc);
      yydestruct (yytoken, &yylval);
      yychar = YYEMPTY;

    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab2;


/*----------------------------------------------------.
| yyerrlab1 -- error raised explicitly by an action.  |
`----------------------------------------------------*/
yyerrlab1:

  /* Suppress GCC warning that yyerrlab1 is unused when no action
     invokes YYERROR.  */
#if defined (__GNUC_MINOR__) && 2093 <= (__GNUC__ * 1000 + __GNUC_MINOR__) \
    && !defined __cplusplus
  __attribute__ ((__unused__))
#endif


  goto yyerrlab2;


/*---------------------------------------------------------------.
| yyerrlab2 -- pop states until the error token can be shifted.  |
`---------------------------------------------------------------*/
yyerrlab2:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
      yydestruct (yystos[yystate], yyvsp);
      yyvsp--;
      yystate = *--yyssp;

      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;


  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*----------------------------------------------.
| yyoverflowlab -- parser overflow comes here.  |
`----------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}


#line 1375 "qmparse.y"


yyerror(s)
	char           *s;
{
  if (thr->qmstat == OK && (thr > thr0 || !checkbrk) &&
      (strcmp(s, "parse error") == 0 || strcmp(s, "syntax error") == 0))
    thr->qmstat = SYNTAX_ERR;
}

/* routines to construct expressions: */

static swap()
	/* swap the topmost two stack elements */
{
  EXPR		*x;

  x = thr->xsp[-2]; thr->xsp[-2] = thr->xsp[-1]; thr->xsp[-1] = x;
  return (1);
}

static pushbin(fno)
     /* process binary op */
     int		fno;
{
  return (swap() && pushfun(thr, fno) && swap() && pushfun(thr, APPOP) &&
	  swap() && pushfun(thr, APPOP));
}

static pushun(fno)
	/* process unary op */
     int		fno;
{
  return (pushfun(thr, fno) && swap() && pushfun(thr, APPOP));
}

static pushlist(n)
	/* process list elements */
     int		n;
{
  while (--n > 0)
    if (!pushfun(thr, CONSOP)) return 0;
  return 1;
}

static pushtuple(n)
	/* process tuple elements */
     int		n;
{
  while (--n > 0)
    if (!pushfun(thr, PAIROP)) return 0;
  return 1;
}

/* eval stats */

static init_stats()
{
  thr0->stats_init = 1;
  thr0->stats_fini = 0;
  thr0->nredns = thr0->nexprs = thr0->maxexprs = 0;
  thr0->starttime = clock();
  return 1;
}

static fini_stats()
{
  thr0->endtime = clock();
  thr0->stats_fini = 1;
  return 1;
}

static print_stats(all)
     int all;
{
  THREAD *thr;
  for (thr = thr0; thr < thr0+(all?nthreads:1); thr++)
    if (thr->used && (thr == thr0 || !thr->active) && thr->stats_init) {
      if (!thr->stats_fini ||
	  thr->starttime == (clock_t)-1 ||
	  thr->endtime == (clock_t)-1)
	if (all || thr > thr0)
	  printf("thread #%d: %lu reduction%s, %lu cell%s\n",
		 thr-thr0,
		 thr->nredns, thr->nredns!=1?"s":"",
		 thr->maxexprs, thr->maxexprs!=1?"s":"");
	else
	  printf("%lu reduction%s, %lu cell%s\n",
		 thr->nredns, thr->nredns!=1?"s":"",
		 thr->maxexprs, thr->maxexprs!=1?"s":"");
      else
	if (all || thr > thr0)
	  printf("thread #%d: %0.3g secs, %lu reduction%s, %lu cell%s\n",
		 thr-thr0,
		 ((double)(thr->endtime-thr->starttime))/(double)CLOCKS_PER_SEC,
		 thr->nredns, thr->nredns!=1?"s":"",
		 thr->maxexprs, thr->maxexprs!=1?"s":"");
	else
	  printf("%0.3g secs, %lu reduction%s, %lu cell%s\n",
		 ((double)(thr->endtime-thr->starttime))/(double)CLOCKS_PER_SEC,
		 thr->nredns, thr->nredns!=1?"s":"",
		 thr->maxexprs, thr->maxexprs!=1?"s":"");
  }
}

/* parse actions: */

extern char *actchar();

static error_report(base, p, tok)
     char *base, *p, *tok;
{
  char *q = p, *r =strchr(p, '\n'), *s, *t, c;
  int l = strlen(tok);
  while (q > base && q[-1] != '\n') --q;
  if (r) c = *r, *r = 0;
  if (tok && *tok && p-q >= l)
    if (strncmp(p-l, tok, l) == 0)
      p -= l;
    else if (p-q >= l+1 && strncmp(p-l-1, tok, l) == 0)
      /* token may actually be off one to the left because of lookahead */
      p -= l+1;
/*     else */
      /* token not found; assume it's the character to the left of the
	 current position */
/*       --p; */
  else
    --p;
  if (tok && strcmp(tok, "\"") == 0 && *p == '"') {
    /* it's a string token, try to back up to the beginning of the string */
    while (p > q && (p[-1] != '"' || p > q+1 && p[-2] == '\\')) --p;
    if (p > q && p[-1] == '"') --p;
  }
  if (p < q) p = q;
  s = malloc((p-q+2)*sizeof(char));
  if (!s) fatal("memory overflow");
  strncpy(s, q, p-q+1);
  s[p-q+1] = 0;
  for (t = s; *t; t++)
    if (!isspace(*t))
      *t = ' ';
  s[p-q] = '^';
  printf(">>> %s\n", q);
  printf("    %s\n", s);
  if (r) *r = c;
  free(s);
}

DECLARE_YYTEXT

static char *tok = NULL, *p = NULL;;
static int toksz = 0;

static savepos()
{
  int l = strlen(yytext);
  p = actchar();
  if (l < 1000) l = 1000;
  if (!tok)
    tok = malloc((toksz = l+1)*sizeof(char));
  else if (toksz < l+1)
    tok = realloc(tok, (toksz = l+1)*sizeof(char));
  if (!tok)
    fatal("memory overflow");
  strcpy(tok, yytext);
}

extern int actlineno;

static clean()
{
  THREAD *thr = get_thr();
  int res = !(thr->qmstat != OK && thr->qmstat != HALT && thr->qmstat != QUIT);
  if (ferror(stdin))
    clearerr(stdin);
  if (!res) {
    if (pmode == SOURCE) {
      char msg[MAXSTRLEN];
      sprintf(msg, "File %s, line %d: %s", psource, actlineno,
	      qmmsg[thr->qmstat]);
      error(msg);
    } else
      error(qmmsg[thr->qmstat]);
    if (thr->qmstat == XCEPT && thr->xsp > thr->xst) {
      printx(thr->xsp[-1]); printf("\n");
    }
    if ((pmode == INTERACT || pmode == SOURCE) && base && p)
      error_report(base, p, tok);
  }
  if (!quitflag && thr->qmstat != QUIT)
    clear(0);
  thr->debug = debug;
  thr->mode = 1;
  return res && !checkbrk;
}

static expression()
{
#ifdef USE_THREADS
  pthread_mutex_unlock(&parse_mutex);
#endif
  if (!checkbrk && init_stats() && eval(thr, thr->xsp[-1]) && fini_stats() &&
      !checkbrk) {
    printx(thr->xsp[-1]);
    putchar('\n');
    if (thr->xsp[-1]->fno != DEFVAROP)
      setvar(DEFVAROP, thr->xsp[-1]);
  } else if (!checkbrk)
    fini_stats();
#ifdef USE_THREADS
  pthread_mutex_lock(&parse_mutex);
#endif
  savepos();
  return clean();
}

static assignment()
{
#ifdef USE_THREADS
  pthread_mutex_unlock(&parse_mutex);
#endif
  if (!checkbrk && init_stats() && eval(thr, thr->xsp[-1])) {
    thr->nredns++;
    thr->args[0] = thr->xsp[-3];
    thr->args[1] = thr->xsp[-1];
    (*funtb[DEFOP])(thr);
    fini_stats();
  }
#ifdef USE_THREADS
  pthread_mutex_lock(&parse_mutex);
#endif
  savepos();
  return clean();
}

static unassignment(int id)
{
  if (symtb[id].x)
    setvar(id, NULL);
  savepos();
  return clean();
}

/* built-in commands: */

static printstr(s)
     char *s;
{
  printf("%s\n", s);
}

static strparam(a, s)
     char *a, **s;
{
  *s = NULL;
  if (!checkbrk && !(*s = strdup(a)))
    thr->qmstat = MEM_OVF;
  savepos();
  if (clean())
    return *s != NULL;
  else {
    if (*s) free(*s);
    return 0;
  }
}

static intparam(a, i)
     char *a; long *i;
{
  int res = !checkbrk;
  if (res) {
    char *s = a;
    while (isdigit(*s)) s++;
    if (!*s) {
      res = 1;
      *i = atol(a);
    } else
      thr->qmstat = SYNTAX_ERR;
  }
  savepos();
  return clean() && res;
}

static boolparam(a, b)
     char *a; int *b;
{
  int res = !checkbrk;
  if (res)
    if (!strcmp(a, "on"))
      *b = 1;
    else if (!strcmp(a, "off"))
      *b = 0;
    else {
      res = 0;
      thr->qmstat = SYNTAX_ERR;
    }
  savepos();
  return clean() && res;
}

static boolstrparam(a, b, s)
     char *a; int *b; char **s;
{
  int res = !checkbrk;
  *s = NULL;
  if (res)
    if (!strcmp(a, "on"))
      *b = 1;
    else if (!strcmp(a, "off"))
      *b = 0;
    else
      return strparam(a, s);
  savepos();
  return clean() && res;
}

static allparam(a)
     char *a;
{
  int res = !checkbrk;
  if (res)
    if (strcmp(a, "all")) {
      res = 0;
      thr->qmstat = SYNTAX_ERR;
    }
  savepos();
  return clean() && res;
}

static copyright()
{
  if (!checkbrk) {
    printf("\n");
    printf(signon, version, sysinfo, year);
    printf(copying);
  }
  savepos();
  return clean();
}

static shell()
{
  if (!checkbrk) {
    char shell_command[MAXSTRLEN];
    getln(shell_command);
    push_sigint(SIG_DFL);
    system(shell_command);
    pop_sigint();
  }
  savepos();
  return clean();
}

#ifdef USE_READLINE
extern int use_readline;
#else
static histwarn()
{
  static done = 0;
  if (done)
    return;
  else if (gflag || !iflag || !isatty(fileno(stdin)))
    done = 1;
  else {
    error("Warning: history not supported");
    done = 1;
  }
}
#endif

static sethistfile(s)
     char *s;
{
#ifdef USE_READLINE
  if (!gflag && use_readline && histmax > 0) {
    char h[MAXSTRLEN];
    write_history(expand(h, histfile));
  }
#else
  histwarn();
#endif
  if (histfile) free(histfile);
  histfile = s;
#ifdef USE_READLINE
  if (!gflag && use_readline) {
    char h[MAXSTRLEN];
    clear_history();
    if (histmax > 0)
      read_history(expand(h, histfile));
    stifle_history(histmax);
  }
#endif
}

static sethistsize(i)
     int i;
{
  histmax = i>=0?i:0;
#ifdef USE_READLINE
  if (!gflag && use_readline)
    stifle_history(histmax);
#else
  histwarn();
#endif
}

static help(s)
     char *s;
{
  static char *info = NULL;
  char *cmd;
  if (!info && !(info = getenv("INFO_PROGRAM")))
    info = "info";
  if ((cmd = malloc(((s?strlen(s):0)*4+3+
		     strlen(info)+MAXSTRLEN)*sizeof(char)))) {
    if (s) {
      char *buf = malloc(4*strlen(s)+1);
      if (buf) {
	sprintf(cmd, "%s -f qdoc --index-search \"%s\"", info, pstr(buf, s));
	free(buf);
      } else {
	free(cmd);
	thr->qmstat = MEM_OVF;
	return clean();
      }
    } else
      sprintf(cmd, "%s -f qdoc", info);
    push_sigint(SIG_DFL);
    system(cmd);
    pop_sigint();
    free(cmd);
  } else
    thr->qmstat = MEM_OVF;
  return clean();
}

static edit(s)
     char *s;
{
  static char *editor = NULL;
  char *cmd;
  if (!editor && !(editor = getenv("EDITOR")))
    editor = "vi";
  if ((cmd = malloc((4*strlen(s)+strlen(editor)+10)*sizeof(char)))) {
    if (s && *s) {
      char *buf = malloc(4*strlen(s)+1);
      if (buf) {
	sprintf(cmd, "%s \"%s\"", editor, pstr(buf, s));
	free(buf);
      } else {
	free(cmd);
	thr->qmstat = MEM_OVF;
	return clean();
      }
    } else
      strcpy(cmd, editor);
    push_sigint(SIG_DFL);
    system(cmd);
    pop_sigint();
    free(cmd);
  } else
    thr->qmstat = MEM_OVF;
  return clean();
}

static save_vars(s)
     char *s;
{
  FILE	       *fp;
  int		res = 0, i;
  char         *s_bak = save_file, _fformat[30];

  strcpy(_fformat, fformat);
#ifdef HAVE_ISO99_PRINTF
  strcpy(fformat, "%a");
#else
  sprintf(fformat, STDFORMAT, 17);
#endif
  if (!s) {
    if (!save_file) save_file = strdup(".q_vars");
    if (!save_file) {
      error(qmmsg[MEM_OVF]);
      strcpy(fformat, _fformat);
      return 0;
    }
    s = save_file;
  } else
    save_file = s;
  if ((fp = fopen(s, "w"))) {
    /* store variable definitions: */
    for (i = symtbsz; i<symtbsz+tmptbsz; i++)
      if (symtb[i].x && i != DEFVAROP) {
	char str[MAXSTRLEN];
	fprintf(fp, "def %s = ", pname(str, i));
	fprintx(fp, symtb[i].x);
	putc('\n', fp);
      }
    res = !ferror(fp);
    fclose(fp);
  }
  if (!res) {
    char msg[MAXSTRLEN];
    sprintf(msg, qmmsg[FILE_ERR], s);
    error(msg);
    if (save_file && s_bak != save_file) free(save_file);
    save_file = s_bak;
  } else if (s_bak && s_bak != save_file)
    free(s_bak);
  strcpy(fformat, _fformat);
  return res;
}

static clear_vars()
{
  int		i;

  for (i = symtbsz; i<symtbsz+tmptbsz; i++)
    if (symtb[i].x)
      setvar(i, NULL);
  clear(0);
}

int aximpsz = 0, ximpsz = 0;
char **ximp = NULL;

static
search_import(m)
     char *m;
{
  int i;
  char modname[MAXSTRLEN];
  for (i = 0; i < ximpsz; i++) {
    basename(modname, ximp[i], '.');
    if (!strcmp(modname, m))
      return i;
  }
  return NONE;
}

static
add_import(s)
     char *s;
{
  int mno;
  char modname[MAXSTRLEN], fname[MAXSTRLEN], fname2[MAXSTRLEN],
    aname[MAXSTRLEN];
  if (!s) return 0;
  basename(modname, s, '.');
  if ((mno = getmodno(modname)) != NONE && 
      (mno == 0 || mno == mainno || globs[mno])) {
    printf("module %s already imported\n", modname);
    free(s);
    return 0;
  }
  if (search_import(modname) != NONE) {
    printf("module %s already imported\n", modname);
    free(s);
    return 0;
  }
  absname(aname, searchlib(fname, s));
  if (!chkfile(aname)) {
    strcat(strcpy(fname2, s), ".q");
    absname(aname, searchlib(fname, fname2));
  }
  if (!chkfile(aname)) {
    printf("file %s not found\n", s);
    free(s);
    return 0;
  }
  if (ximpsz >= aximpsz) {
    char **ximp1;
    if (!(ximp1 = arealloc(ximp, aximpsz, 10, sizeof(char*)))) {
      printf("error processing %s -- out of memory\n", s);
      free(s);
      return 0;
    } else {
      ximp = ximp1;
      aximpsz += 10;
    }
  }
  ximp[ximpsz++] = s;
  return 1;
}

extern char *source;

static
del_import(s)
     char *s;
{
  char modname[MAXSTRLEN], fname[MAXSTRLEN], fname2[MAXSTRLEN],
    aname[MAXSTRLEN];
  int i, mno, pos;
  if (!s) return 0;
  basename(modname, s, '.');
  absname(aname, searchlib(fname, s));
  if (!chkfile(aname)) {
    strcat(strcpy(fname2, s), ".q");
    absname(aname, searchlib(fname, fname2));
  }
  pos = search_import(modname);
  mno = getmodno(modname);
  if (mno != NONE && mno != mainno && mno != 0 && !globs[mno])
    mno = NONE;
  if (mno != NONE && strcmp(aname, strsp+fnametb[mno])) {
    printf("module %s not imported\n", modname);
    return 0;
  }
  if (mno == NONE || pos == NONE && mno != mainno) {
    if (mno != NONE)
      printf("module %s cannot be unloaded\n", modname);
    else
      printf("module %s not imported\n", modname);
    return 0;
  }
  if (mno == mainno) {
    if (source) free(source);
    source = NULL;
  }
  if (pos != NONE) {
    free(ximp[pos]);
    for (i = pos+1; i < ximpsz; i++)
      ximp[i-1] = ximp[i];
    ximpsz--;
  }
  return 1;
}

static
clear_imports()
{
  if (ximpsz) {
    int i;
    for (i = 0; i < ximpsz; i++)
      free(ximp[i]);
    ximpsz = 0;
    return 1;
  } else
    return 0;
}

static
modcmp(v1, v2)
	int	       *v1, *v2;
{
	return strcmp(strsp + modtb[*v1], strsp + modtb[*v2]);
}

static
print_modlist()
{
  int i, n, *v, *v0;
  if (modtbsz <= 0)
    return;
  else if (!(v = (int *)calloc(modtbsz, sizeof(int)))) {
    thr->qmstat = MEM_OVF;
    return;
  }
  for (i = 0; i < modtbsz; i++) v[i] = i;
  qsort(v, modtbsz, sizeof(int), (int(*)())modcmp);
  v0 = v; n = modtbsz;
  if (!strsp[modtb[*v]]) {
    v++; n--;
  }
  if (iflag) {
    for (i = 0; i < n; i++) {
      if (i > 0)
	if (i % 4 == 0)
	  printf("\n");
	else
	  printf("\t");
      if (dll_name[v[i]]) {
	char modn[MAXSTRLEN];
	strcat(strcpy(modn, strsp+modtb[v[i]]), "*");
	printf("%-15s", modn);
      } else
	printf("%-15s", strsp+modtb[v[i]]);
    }
    printf("\n");
  } else {
    for (i = 0; i < n; i++)
      printf("%s%s\n", strsp+modtb[v[i]], dll_name[v[i]]?"*":" ");
  }
  free(v0);
}

static modules()
{
  if (!checkbrk) {
    print_modlist();
  }
  savepos();
  return clean();
}

static
print_implist()
{
  int i, n = 0, *v;
  for (i = 0; i < modtbsz; i++) 
    if (strsp[modtb[i]])
      if (i == 0 || i == mainno || globs[i])
	n++;
  if (n <= 0)
    return;
  else if (!(v = (int *)calloc(n, sizeof(int)))) {
    thr->qmstat = MEM_OVF;
    return;
  }
  n = 0;
  for (i = 0; i < modtbsz; i++) 
    if (strsp[modtb[i]])
      if (i == 0 || i == mainno || globs[i])
	v[n++] = i;
  qsort(v, n, sizeof(int), (int(*)())modcmp);
  if (iflag) {
    for (i = 0; i < n; i++) {
      char modn[MAXSTRLEN];
      if (i > 0)
	if (i % 4 == 0)
	  printf("\n");
	else
	  printf("\t");
      sprintf(modn, "%s%s%s",
	      (v[i] == mainno||search_import(strsp+modtb[v[i]])!=NONE)?"+":"",
	      strsp+modtb[v[i]], dll_name[v[i]]?"*":" ");
      printf("%-15s", modn);
    }
    printf("\n");
  } else {
    for (i = 0; i < n; i++)
      printf("%s%s%s\n",
	     (v[i] == mainno||search_import(strsp+modtb[v[i]])!=NONE)?"+":"",
	     strsp+modtb[v[i]], dll_name[v[i]]?"*":" ");
  }
  free(v);
}

static import_list()
{
  if (!checkbrk) {
    print_implist();
  }
  savepos();
  return clean();
}

static
idcmp(v1, v2)
     int	       *v1, *v2;
{
  int cmp = strcmp(strsp + symtb[*v1].pname, strsp + symtb[*v2].pname);
  if (cmp)
    return cmp;
  else
    return strcmp(strsp + modtb[symtb[*v1].modno],
		  strsp + modtb[symtb[*v2].modno]);
}

static
print_varlist(int all)
{
  int	       *v, n, i, sz = all?BINARY:symtbsz;
  char		s[MAXSTRLEN];
  for (n = 0, i = sz; i < symtbsz+tmptbsz; i++)
    if (visible(i) && symtb[i].x)
      n++;
  if (n == 0) {
    /* 		printf("*** no defined symbols ***\n"); */
    return;
  } else if (!(v = (int *)calloc(n, sizeof(int)))) {
    thr->qmstat = MEM_OVF;
    return;
  }
  for (n = 0, i = sz; i < symtbsz+tmptbsz; i++)
    if (visible(i) && symtb[i].x)
      v[n++] = i;
  qsort(v, n, sizeof(int), (int(*)())idcmp);
  if (iflag) {
    for (i = 0; i < n; i++) {
      if (i > 0)
	if (i % 4 == 0)
	  printf("\n");
	else
	  printf("\t");
      printf("%-15s", pname(s, v[i]));
    }
    printf("\n");
  } else {
    for (i = 0; i < n; i++)
      printf("%s\n", pname(s, v[i]));
  }
  free(v);
}

print_breakpoints()
{
  int	       *v, n, i;
  char		s[MAXSTRLEN];
  printf("break is %s", brkdbg?"on":"off");
  for (n = 0, i = BINARY; i < symtbsz+tmptbsz; i++)
    if (visible(i) && (symtb[i].flags&(BRK|TBRK)))
      n++;
  if (n == 0) {
    /* 		printf(", no breakpoints\n"); */
    printf("\n");
    return;
  } else if (!(v = (int *)calloc(n, sizeof(int)))) {
    thr->qmstat = MEM_OVF;
    return;
  }
  for (n = 0, i = BINARY; i < symtbsz+tmptbsz; i++)
    if (visible(i) && (symtb[i].flags&(BRK|TBRK)))
      v[n++] = i;
  qsort(v, n, sizeof(int), (int(*)())idcmp);
  printf(", %d breakpoint%s\n", n, (n>1)?"s":"");
  if (iflag) {
    for (i = 0; i < n; i++) {
      if (i > 0)
	if (i % 4 == 0)
	  printf("\n");
	else
	  printf("\t");
      pname(s, v[i]);
      if (symtb[v[i]].flags & TBRK)
	strcat(s, "*");
      printf("%-15s", s);
    }
    printf("\n");
  } else {
    for (i = 0; i < n; i++)
      printf("%s\n", pname(s, v[i]));
  }
  free(v);
}

static breakpoints()
{
  if (!checkbrk) print_breakpoints();
  savepos();
  return clean();
}

static
profcmp(v1, v2)
     int	       *v1, *v2;
{
  int cmp = symtb[*v2].nredns - symtb[*v1].nredns;
  if (cmp)
    return cmp;
  else {
    cmp = strcmp(strsp + symtb[*v1].pname, strsp + symtb[*v2].pname);
    if (cmp)
      return cmp;
    else
      return strcmp(strsp + modtb[symtb[*v1].modno],
		    strsp + modtb[symtb[*v2].modno]);
  }
}

print_profile()
{
  int	       *v, n, i;
  char		s[MAXSTRLEN];
  for (n = 0, i = BINARY; i < symtbsz+tmptbsz; i++)
    if (visible(i) && (symtb[i].flags&PROF))
      n++;
  if (n == 0)
    return;
  else if (!(v = (int *)calloc(n, sizeof(int)))) {
    thr->qmstat = MEM_OVF;
    return;
  }
  for (n = 0, i = BINARY; i < symtbsz+tmptbsz; i++)
    if (visible(i) && (symtb[i].flags&PROF))
      v[n++] = i;
  qsort(v, n, sizeof(int), (int(*)())profcmp);
  for (i = 0; i < n; i++) {
    printf("%8d\t%s\n", symtb[v[i]].nredns, pname(s, v[i]));
    symtb[v[i]].nredns = 0;
  }
  free(v);
}

static profile()
{
  if (!checkbrk) print_profile();
  savepos();
  return clean();
}

static who(int all)
{
  if (!checkbrk) print_varlist(all);
  savepos();
  return clean();
}

static whos(int sym)
{
  printf("\n");
  if (sym >= BINARY) {
    int mno = symtb[sym].modno,
      flags = symtb[sym].flags,
      argc = symtb[sym].argc,
      type = symtb[sym].type;
    unsigned long argv = symtb[sym].argv;
    EXPR *x = (EXPR*)symtb[sym].x;
    char s[MAXSTRLEN], ts[MAXSTRLEN];
    
    pname(s, sym);
    if (type) pname(ts, type);
    if (mno == NONE || sym < BUILTIN || !(flags & DCL)) {
      if ((flags & VSYM) && !x)
	printf("%-15s\tnot a defined symbol", s);
      else
	printf("%-15s\t%s %s%s%s symbol", s,
	       (sym<BUILTIN)?"builtin":"user-defined",
	       argv?"special ":"",
	       (flags&CST)?"const ":"",
	       (flags&VSYM)?"variable":"function");
      if ((flags&EXT) && symtb[sym].xfno!=sym)
	printf("\n%-15s\texternal override in %s", " ",
	       strsp+fnametb[symtb[symtb[sym].xfno].modno]);
    } else {
      printf("%-15s\t%s%s%s%s symbol defined in %s", s,
	     (flags&PRIV)?"private ":"",
	     argv?"special ":"",
	     (flags&CST)?"const ":"",
	     (flags&VSYM)?"variable":
	     ((flags&EXT)&&symtb[sym].xfno==sym)?"external function":
	     "function",
	     strsp+fnametb[mno]);
      if ((flags&EXT) && symtb[sym].xfno!=sym)
	printf("\n%-15s\texternal override in %s", " ",
	       strsp+fnametb[symtb[symtb[sym].xfno].modno]);
    }
    if (type)
      printf("\n%-15s\t%s %s", " ", ts, s);
    else if (argc > 0)
      printf("\n%-15s\t%s", " ", s);
    if (argc > 0) {
      int i;
      for (i = 0; i < argc; i++) {
	printf(" ");
	if (argv && !((argv>>i)&1)) printf("~");
	printf("$%d", i+1);
      }
    }
    if (type) {
      int tmno = symtb[type].modno;
      if (tmno == NONE || type < BUILTIN)
	printf("\n%-15s\tbuiltin type %s", " ", ts);
      else
	printf("\n%-15s\t%s%stype %s defined in %s", " ",
	       (symtb[type].flags&PRIV)?"private ":"",
	       (symtb[type].flags&EXT)?"external ":"", ts,
	       strsp+fnametb[tmno]);
    } else if (x) {
      printf("\n%-15s\t= ", " ");
      printx(x);
    }
    printf("\n");
  } else
    printf("unknown or bad symbol\n");
  savepos();
  return clean();
}

/* make the parser reentrant */

static struct {
  int yychar, yynerrs;
  YYSTYPE yylval;
  THREAD *thr;
} yystack[MAXSTACK], *yystptr = NULL;

static yypush()
{
  if (yystptr) {
    if (yystptr - yystack >= MAXSTACK)
      fatal("source stack overflow");
    yystptr->yychar = yychar;
    yystptr->yynerrs = yynerrs;
    memcpy(&yystptr->yylval, &yylval, sizeof(YYSTYPE));
    yystptr->thr = thr;
    yystptr++;
  } else
    yystptr = yystack;
}

static yypop()
{
  if (yystptr > yystack) {
    --yystptr;
    yychar = yystptr->yychar;
    yynerrs = yystptr->yynerrs;
    memcpy(&yylval, &yystptr->yylval, sizeof(YYSTYPE));
    thr = yystptr->thr;
  } else
    yystptr = NULL;
}

/* generic parse routine: */

static parse(source, _mode)
     void	       *source;
     int		_mode;
{
  int c, actmode;
  long xbp;
  THREAD *_thr = get_thr();
  actmode = _thr->mode;
  xbp = _thr->xsp-_thr->xst;
  if (!initlex(source, _mode)) {
    _thr->qmstat = STACK_OVF;
    return 0;
  };
  yypush();
  thr = _thr;
  thr->mode = 1;
  if (_mode == INTERACT || _mode == SOURCE)
    base = (char*)source;
  else
    base = NULL;	
  if (yyparse()) {
    if (_mode == INTERACT || _mode == SOURCE) {
      thr->debug = debug;
      savepos();
    }
    thr->mode = actmode;
    if (_mode == LINE)
      /* skip remainder of input line */
      if (yychar && yychar != 10 && (thr > thr0 || !checkbrk)) skip();
    finilex();
    /* clean up the stack: */
    while (thr->xsp-thr->xst > xbp)
      qmfree(thr, *--thr->xsp);
    yypop();
    return (0);
  } else {
    if (_mode == INTERACT || _mode == SOURCE) {
      thr->debug = debug;
      savepos();
    }
    thr->mode = actmode;
    finilex();
    yypop();
    return (1);
  }
}

/* interface routines: */

int sparsex(char *s)
{
  int ret;
#ifdef USE_THREADS
  pthread_mutex_lock(&parse_mutex);
#endif
  ret = parse(s, STRING);
#ifdef USE_THREADS
  pthread_mutex_unlock(&parse_mutex);
#endif
  return ret;
}

int fparsex(FILE *fp)
{
  THREAD *thr = get_thr();
  int ret;
#ifdef USE_THREADS
  pthread_mutex_lock(&parse_mutex);
#endif
  ret = parse(fp, LINE);
#ifdef USE_THREADS
  pthread_mutex_unlock(&parse_mutex);
#endif
  if (ret)
    if (thr == thr0 && checkbrk) {
      qmfree(thr, *--thr->xsp);
      return 0;
    } else
      return 1;
  else
    return 0;
}

int parsesrc(char *fname, int chk)
{
  char *buf;
  FILE *fp;
  THREAD *thr = get_thr();
  if (!chkfile(fname) || !(fp = fopen(fname, "r"))) {
    char msg[MAXSTRLEN];
    sprintf(msg, qmmsg[FILE_NOT_FOUND], fname);
    error(msg);
    return 0;
  }
#ifdef USE_THREADS
  pthread_mutex_lock(&parse_mutex);
#endif
  psource = fname;
  actlineno = 0;
  while (!quitflag && thr->qmstat != QUIT && (buf = getline(fp, "", 0))) {
    if (eflag) echo(buf);
    if (!parse(buf, SOURCE)) {
      if (thr->qmstat == BAD_OBJ) thr->qmstat = chk?SYNTAX_ERR:OK;
      clean();
      free(buf);
#ifdef USE_THREADS
      pthread_mutex_unlock(&parse_mutex);
#endif
      return 0;
    }
    free(buf);
    fflush(stderr);
    fflush(stdout);
  }
  fclose(fp);
#ifdef USE_THREADS
  pthread_mutex_unlock(&parse_mutex);
#endif
  return 1;
}

int parsex(char *s)
{
  int ret;
#ifdef USE_THREADS
  pthread_mutex_lock(&parse_mutex);
#endif
  ret = parse(s, INTERACT);
#ifdef USE_THREADS
  pthread_mutex_unlock(&parse_mutex);
#endif
  if (!ret)
    return clean();
  else
    return 1;
}

